/********************************************************************
 FileName:     	HardwareProfile.h
 Dependencies:	See INCLUDES section
 Processor:		24F
 Hardware:		
 Complier:  
 Company:		UB
********************************************************************/
#ifndef HARDWARE_PROFILE_PIC24FJ64GB004_PIM_H
#define HARDWARE_PROFILE_PIC24FJ64GB004_PIM_H


    //#define USE_SELF_POWER_SENSE_IO
    #define tris_self_power     TRISAbits.TRISA2    // Input
    #define self_power          1

    //#define USE_USB_BUS_SENSE_IO
    #define tris_usb_bus_sense  TRISBbits.TRISB5    // Input
    #define USB_BUS_SENSE       1 
   
    //Uncomment this to make the output HEX of this project 
    //   to be able to be bootloaded using the HID bootloader
    #define PROGRAMMABLE_WITH_USB_HID_BOOTLOADER	

    //If the application is going to be used with the HID bootloader
    //  then this will provide a function for the application to 
    //  enter the bootloader from the application (optional)
    #if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
        #define EnterBootloader() __asm__("goto 0x400")
    #endif   

    #define DEMO_BOARD PIC24FJ64GB004_PIM
    #define EXPLORER_16
    #define PIC24FJ64GB004_PIM
    #define CLOCK_FREQ 32000000
    
    /** LED ************************************************************/
    #define mInitAllLEDs()      LATA &= 0xFB7C; TRISA &= 0xFB7C; LATB &= 0x1FFF; TRISB &= 0x1FFF; LATC &= 0xFCFE ;TRISC &=0xFCFE; 
    
    #define LAMPARA1_A             	LATAbits.LATA10
    #define LAMPARA1_B             	LATBbits.LATB13
    #define LAMPARA2_A             	LATBbits.LATB14
    #define LAMPARA2_B             	LATAbits.LATA7

    #define LAMPARA3_A             	LATAbits.LATA0
    #define LAMPARA3_B             	LATBbits.LATB15
    #define LAMPARA4_A             	LATCbits.LATC0
    #define LAMPARA4_B             	LATAbits.LATA1

    #define LED_STATUS            	LATCbits.LATC9
 	//#define LED_AVERIA            	LED_STATUS 	//DEBUG 
   	#define LED_AVERIA            	LATCbits.LATC8

    #define LAMPARA1_COLOR1()		LAMPARA1_A=1;LAMPARA1_B=1;	//HARTING 7A + 7B -
    #define LAMPARA1_COLOR2()   	LAMPARA1_A=0;LAMPARA1_B=0; 	//HARTING 7A - 7B +
	#define LAMPARA1_OFF()      	LAMPARA1_A=1;LAMPARA1_B=0;	//HARTING 7A 0 7B 0

    #define LAMPARA2_COLOR1()		LAMPARA2_A=1;LAMPARA2_B=1;	//HARTING 7C + 8A -
    #define LAMPARA2_COLOR2()  		LAMPARA2_A=0;LAMPARA2_B=0;	//HARTING 7C - 8A +
	#define LAMPARA2_OFF()     		LAMPARA2_A=1;LAMPARA2_B=0;	//HARTING 7C 0 8A 0

    #define LAMPARA3_COLOR1()		LAMPARA3_A=1;LAMPARA3_B=1;	//HARTING 8B + 8C -
    #define LAMPARA3_COLOR2()   	LAMPARA3_A=0;LAMPARA3_B=0;	//HARTING 8B - 8C +
	#define LAMPARA3_OFF()      	LAMPARA3_A=1;LAMPARA3_B=0;	//HARTING 8B 0 8C 0

    #define LAMPARA4_COLOR1()		LAMPARA4_A=1;LAMPARA4_B=1;	//HARTING 9A + 9C -
    #define LAMPARA4_COLOR2()   	LAMPARA4_A=0;LAMPARA4_B=0;	//HARTING 9A - 9C +
	#define LAMPARA4_OFF()      	LAMPARA4_A=1;LAMPARA4_B=0;	//HARTING 9A 0 9C 0
	
	#define LED_STATUS_On()     	LED_STATUS=1;
	#define LED_STATUS_Off()    	LED_STATUS=0;
	#define LED_AVERIA_On()     	LED_AVERIA=1;
	#define LED_AVERIA_Off()    	LED_AVERIA=0;

    #define LED_STATUS_Toggle()     LED_STATUS ^= 1; 
    #define LED_AVERIA_Toggle()     LED_AVERIA ^= 1; 

    
    /** SWITCH *********************************************************/
	#define IN1_Tris()      			TRISCbits.TRISC1=1;
	#define IN2_Tris()      			TRISCbits.TRISC2=1;
	#define IN3_Tris()      			TRISAbits.TRISA8=1;
	#define IN4_Tris()      			TRISBbits.TRISB4=1;
	#define IN5_Tris()      			TRISAbits.TRISA4=1;
	#define IN6_Tris()      			TRISAbits.TRISA9=1;
	#define IN7_Tris()      			TRISCbits.TRISC3=1;
	#define IN8_Tris()      			TRISCbits.TRISC4=1;
	#define IN9_Tris()      			TRISCbits.TRISC5=1;
	#define IN10_Tris()      			TRISBbits.TRISB5=1;

	#define IN11_Tris()      			TRISBbits.TRISB7=1;		//power ok

	#define IN_RELE     		!PORTCbits.RC1
	#define IN_P1_NO   	 		!PORTCbits.RC2
	#define IN_P1_NC     		!PORTAbits.RA8
	#define IN_P2_NO    		!PORTBbits.RB4
	#define IN_P2_NC    		!PORTAbits.RA4
	#define IN_P3_NO   			!PORTAbits.RA9
	#define IN_P3_NC  			!PORTCbits.RC3
	#define IN_P4_NO  			!PORTCbits.RC4
	#define IN_P4_NC   			!PORTCbits.RC5
	#define IN_BYPASS     		!PORTBbits.RB5
	#define IN_PWR_OK    		PORTBbits.RB7


    /** I/O pin definitions ********************************************/
    #define INPUT_PIN 1
    #define OUTPUT_PIN 0

#endif  //HARDWARE_PROFILE_PIC24FJ64GB004_PIM_H
