/********************************************************************
 FileName:     	InterruptTimer.c
 Dependencies:	See INCLUDES section
 Processor:		24F
 Hardware:		
 Complier:  
 Company:		UB
********************************************************************/

/** INCLUDES  ******************************************************/
#include <p24Fxxxx.h>
#include "funcionalidad.h"
#include "eeprom.h"
/** DEFINITIONS ****************************************************/
#define ConsTimer_1s	100	
#define ConsTimer_60m	360	
#define ConsTimer_120m	720	
#define ConsTimer_180m	1080	
/** FUNCTIONS ****************************************************/
void FunTimer_1s(void);
/** VARIABLES ****************************************************/
unsigned int mSecond;
unsigned int dSecond;
unsigned int dSecond_ant;
unsigned int difmSecond;
unsigned int timerInit;
unsigned int VarTimer_1s;
unsigned int VarTimer_Punteros;
unsigned int TimerUart1ms;
unsigned int RandomNum;

void _ISR __attribute__ ((no_auto_psv)) _T1Interrupt(void) 
{
	//Timer 1ms
	if(!Fun_Pwr_Ok())
	{
		//Se ha producido un corte de alimentacin pero no se ha podido grabar por i2c ocupado
		//TODO OJO hay que esperarse a siguiente interrupcin para ver
	}
	else
	{
		//No hay corte alimentacin
		FiltrarInputs();
		if (TimerUart1ms) TimerUart1ms--;
	}
	RandomNum++;
	if(RandomNum>=256)	RandomNum=0;
	IFS0bits.T1IF = 0; //Reset Timer1 interrupt flag and Return from ISR
}

void _ISR __attribute__ ((no_auto_psv)) _T2Interrupt(void) 
{
	//Timer 10ms
	mSecond = mSecond+10;
	if(mSecond<100) 	dSecond =0;
	if(mSecond>=100) 	dSecond =1;
	if(mSecond>=200) 	dSecond =2;
	if(mSecond>=300) 	dSecond =3;
	if(mSecond>=400) 	dSecond =4;
	if(mSecond>=500) 	dSecond =5;
	if(mSecond>=600) 	dSecond =6;
	if(mSecond>=700) 	dSecond =7;
	if(mSecond>=800) 	dSecond =8;
	if(mSecond>=900) 	dSecond =9;
	if(mSecond>=999) 	mSecond =0;

	if(!geti2cOcupado());
	{
		seti2cOcupado(1);
		SaveEventosRAM();
		seti2cOcupado(0);
	}
	Funcionalidad();
	//Timer 1 s
	if(VarTimer_1s)			VarTimer_1s--;
	else					FunTimer_1s();

	//LATCbits.LATC8 ^= 1;
	IFS0bits.T2IF = 0; //Reset Timer1 interrupt flag and Return from ISR
}
//Funcion cada segundo
void FunTimer_1s()
{
	//Timer Para salvar Punteros
	if(VarTimer_Punteros)	VarTimer_Punteros--;
	else					FunTimer_Punteros();
	if(!geti2cOcupado());
	{
		seti2cOcupado(1);
		SaveEventosEEPROM();
		SaveAveriasEEPROMFun();
		seti2cOcupado(0);
		VarTimer_1s=ConsTimer_1s;
	}
}
//Funcion cada Salvar Punteros
void FunTimer_Punteros()
{
	if(!geti2cOcupado());
	{
		seti2cOcupado(1);
		SavePunterosEEPROM();
		seti2cOcupado(0);
		VarTimer_Punteros=ConsTimer_120m;
	}
}

unsigned int getdSecond(void)					
{	
	return dSecond;
}
void setdSecond(unsigned int valor)				
{
	dSecond=valor;
}
unsigned int getmSecond(void)					
{	
	return mSecond;
}
void setmSecond(unsigned int valor)				
{
	mSecond=valor;
}
unsigned int getdSecondAnt(void)					
{	
	return dSecond_ant;
}
void setdSecondAnt(unsigned int valor)				
{
	dSecond_ant=valor;
}
unsigned int getTimerInit(void)				
{
	return timerInit;
}
void setTimerInit(unsigned int valor)	
{
	timerInit=valor;
}
unsigned int getTimerUart1ms(void)				
{
	return TimerUart1ms;
}
void setTimerUart1ms(unsigned int valor)	
{
	TimerUart1ms=valor;
}
unsigned int getRandomNum(void)
{
	return RandomNum;
}
