/********************************************************************
 FileName:     	funcionalidad.c
 Dependencies:	See INCLUDES section
 Processor:		24F
 Hardware:		
 Complier:  
 Company:		UB
********************************************************************/

/** INCLUDES  ******************************************************/
#include "funcionalidad.h"
/** DEFINITIONS ****************************************************/
#define MAXEVENTOSRAM			10								//Maximos Eventos en RAM
#define InterrupT2_Off()		IEC0bits.T2IE = 0 				//Disable T2 interrupts
#define InterrupT2_On()			IEC0bits.T2IE = 1 				//Enable T2 interrupts
#define InterrupT1_Off()		IEC0bits.T1IE = 0 				//Disable T1 interrupts
#define InterrupT1_On()			IEC0bits.T1IE = 1 				//Enable T1 interrupts
#define BCD2BIN(val) 			(((val)&15) + ((val)>>4)*10)  	//conversion Bcd a Binario
#define BIN2BCD(val) 			((((val)/10)<<4) + (val)%10) 	//conversion Binario a Bcd 
/** V A R I A B L E S ********************************************************/
MyByte		 	Eventos[MAXEVENTOSRAM][6];
unsigned int 	cntEventos;
unsigned int 	indexEventos_INI,indexEventos_FIN;
unsigned char 	Estado;
unsigned char 	USB_In_Buffer[64];
unsigned char 	USB_Out_Buffer[255];
unsigned char 	ETH_In_Buffer[64];
unsigned char 	ETH_Out_Buffer[255];
unsigned int 	cntDatos;
unsigned int 	cntPaquetes;
unsigned int 	PaquetesTotales;
unsigned int 	PaqueteActual;
unsigned int 	EsperaRele;
unsigned int 	EsperaPuertas;
MyByte  		Year,Month,Day,Hour,Minute,Second,Decima;
MyByte  		Second_ANT;
MyByte  		NumEntrada;
MyByte  		Codificacion;
MyByte  		colorPulsado;
MyByte  		pulsadorPulsado;

BOOL	i2cOcupado;
BOOL	PuertasCerradasF, PuertasAbiertasF;
//Inputs Pulsadores NO/NC
BOOL	P1_NO,P2_NO,P3_NO,P4_NO,P5_NO,P6_NO,P7_NO,P8_NO;
//Inputs Pulsadores NO/NC ANTERIOR
BOOL	P1_NO_ANT,P2_NO_ANT,P3_NO_ANT,P4_NO_ANT;
BOOL	BYPASS_ANT;
//Flancos Subida Pulsadores
BOOL	FS_P1_NO,FS_P2_NO,FS_P3_NO,FS_P4_NO;
//Flancos Bajada Pulsadores
BOOL	FB_P1_NO,FB_P2_NO,FB_P3_NO,FB_P4_NO;
BOOL	FS_BYPASS,FB_BYPASS;

BOOL 	BYPASS;

BOOL 	PulsadorPulsado;
//Test de EEPROM
BOOL	EEPROM1_OK,EEPROM2_OK,EEPROM3_OK,RTC_OK, PROBADOR_INI;
//Version de Soft
unsigned char vSoft[4];
MyByte Averias1, Averias2;
/** VARIABLES DE CONFIGURACION **********************************************/
//Colores del las lamparas al encenderse
unsigned char ColorLampara1,ColorLampara2,ColorLampara3,ColorLampara4;
//Pueden coger valores 00, 01, 10 Apagado, Color 1, Color 2
unsigned char Lampara1,Lampara2,Lampara3,Lampara4;
//Combinaciones de lamparas posibles en modo aleatorio
unsigned int 	cntCombValidas;
unsigned char 	CombLamparas1[4];
MyByte 			SalidasCombLamparas1;
unsigned char 	CombLamparas2[4];
MyByte 			SalidasCombLamparas2;
unsigned char 	CombLamparas3[4];
MyByte 			SalidasCombLamparas3;
// ARRAY DE PARAMETROS
MyByte Parametros[100];
#define CnfLampara1		Parametros[0]
#define CnfLampara2		Parametros[1]
#define CnfLampara3		Parametros[2]
#define CnfLampara4		Parametros[3]
#define Lampara1Salida1	Parametros[4]
#define Lampara1Salida2	Parametros[5]
#define Lampara2Salida1	Parametros[6]
#define Lampara2Salida2	Parametros[7]
#define Lampara3Salida1	Parametros[8]
#define Lampara3Salida2	Parametros[9]
#define Lampara4Salida1	Parametros[10]
#define Lampara4Salida2	Parametros[11]
#define ID_Datalogger0		Parametros[12]
#define ID_Datalogger1		Parametros[13]
#define ID_Datalogger2		Parametros[14]
#define ID_Datalogger3		Parametros[15]
#define ID_Datalogger4		Parametros[16]
#define ID_Datalogger5		Parametros[17]
#define ID_Datalogger6		Parametros[18]
#define ID_Datalogger7		Parametros[19]
#define ID_Datalogger8		Parametros[20]
#define ID_Datalogger9		Parametros[21]
#define ID_Datalogger10		Parametros[22]
#define ID_Datalogger11		Parametros[23]
#define ID_Datalogger12		Parametros[24]
#define ID_Datalogger13		Parametros[25]
#define ID_Datalogger14		Parametros[26]
#define ID_Datalogger15		Parametros[27]
#define ID_Datalogger16		Parametros[28]

#define AveriaEEPROM       	Averias1.bit0		//Error en almenos una posicin de memoria de EEPROM de datos
#define AveriaEEPROM_RTC	Averias1.bit1		//Error en almenos una posicin de memoria de EEPROM de parametros
#define AveriaRELE      	Averias1.bit2		//Error en entrada de control de rele	
#define AveriaPUNTERO      	Averias1.bit3		//Error en de almacenamiento de punteros se puede haber perdido informacin
#define AveriaP1	      	Averias1.bit4		//Error en pulsador 1	TODO
#define AveriaP2	      	Averias1.bit5		//Error en pulsador 2	TODO
#define AveriaP3	      	Averias1.bit6		//Error en pulsador 3	TODO
#define AveriaP4	      	Averias1.bit7		//Error en pulsador 4	TODO

#define AveriaEEPROM_1 		Averias2.bit0		//
#define AveriaEEPROM_2		Averias2.bit1		//
#define AveriaEEPROM_3 		Averias2.bit2		//
#define AveriaPila    		Averias2.bit3		//
#define AveriaParametros	Averias2.bit4		//
#define Averia2	    	  	Averias2.bit5		//
#define Averia3		      	Averias2.bit6		//
#define Averia4		      	Averias2.bit7		//
/** FUNCTIONS ******************************************************/

/******************************************************************************
 * Function:        void UserInit(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This routine should take care of all of the demo code
 *                  initialization that is required.
 *
 * Note:            
 *
 *****************************************************************************/
void UserInit(void)
{
    //Initialize all of the LED pins
	mInitAllLEDs();

    //Initialize inputs
    IN1_Tris();
	IN2_Tris();
	IN3_Tris();
	IN4_Tris();
	IN5_Tris();
	IN6_Tris();
	IN7_Tris();
	IN8_Tris();
	IN9_Tris();
	IN10_Tris();
	IN11_Tris();

	/*245 Bytes por trama  1960 bits --> 2Mb --> 1021 tramas -->  2.001.160 bits */
	PaquetesTotales = 1021;
	PaqueteActual =0;

	//Valores iniciales de EEPROM
	//-1 Err EEPROM RTC, -2 Err EEPROM, -3 Err Puntero, 0 Parametros sin INI
	int retorno;
	retorno=EEPROMInit(Parametros, &Averias1, &Averias2);
	if(retorno==0)	AveriaParametros=1;
	if(retorno==-1)	AveriaEEPROM=1;
	if(retorno==-2)	AveriaEEPROM_RTC=1;
	if(retorno==-3)	AveriaPUNTERO=1;

	//COOMPROBACION EEPROM
	retorno=testEEPROM();
	if(retorno!=0)
	{
		if(retorno==1)	AveriaEEPROM_1=1;
		if(retorno==2)	AveriaEEPROM_2=1;
		if(retorno==3)	AveriaEEPROM_3=1;
	}
	else
	{
		AveriaEEPROM_1=0;
		AveriaEEPROM_2=0;
		AveriaEEPROM_3=0;
	}	
	//RTCC
	//INIT TIMER RTC
	ini_i2c_rtcc();
	i2c_rtcc_wr(ADDR_CTRL,SQWE+ALM_NO+MFP_01H);  
	//i2c_rtcc_wr(ADDR_CTRL,0x00);  //TODO Luis
	AveriaPila =0;	
	if(	!ini_i2c_time())
	{
		// Se han cargado valores por defecto por falta o cambio de Pila
		AveriaPila =1;			
	}
	PedirFecha();
	//INIT UART
	uart1_init();
	//Version soft
	vSoft[0]='0';
	vSoft[1]='1';
	vSoft[2]='.';
	vSoft[3]='0';
	//Apagamos Salidas
	TodoOff();
}//end UserInit

/********************************************************************
 * Function:        void ProcessIO(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is a place holder for other user
 *                  routines. It is a mixture of both USB and
 *                  non-USB tasks.
 *
 * Note:            None
 *******************************************************************/
void ProcessIO(void)
{   
    BYTE numBytesRead;

    //Blink the LED STATUS Segund USB y LED AVERIA
    BlinkUSBStatus();
	BlinkAveria();

    // User Application USB tasks
    if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;

    if(USBUSARTIsTxTrfReady())
    {
		numBytesRead = getsUSBUSART(USB_In_Buffer,64);
		if(numBytesRead != 0)
		{
			int NumDatos;
			numBytesRead=0;
			if(!CompruebaCRC(USB_In_Buffer, USB_In_Buffer[2]))
			{
				//Error en CRC
				USB_In_Buffer[0]=0; //Reset del byte de control para que retorne error
			}
			switch(USB_In_Buffer[0])
			{
				case 0xAA:
					//TRAMA CORRECTA
					switch(USB_In_Buffer[3])
					{
						case 0x01:
						//TRAMA LECTURA EEPROM
							PaquetesTotales= CalcPaquetesEnv();
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0xFF;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = (PaquetesTotales & 0xFF00) >> 8;		//PAQUETE TOTAL H
							USB_Out_Buffer[5] = PaquetesTotales & 0x00FF;		//PAQUETE TOTAL L
							USB_Out_Buffer[6] = USB_In_Buffer[4];			//PAQUETE ACTUAL H
							USB_Out_Buffer[7] = USB_In_Buffer[5];			//PAQUETE ACTUAL L
							if(USB_In_Buffer[4]==0&&USB_In_Buffer[5]==0)
							{
								//Si pide primer paquete reset de puntero de read
								setpunteroRDEEPROM(getpunteroWREEPROM_INI());
							}
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(LeerEEPROM(&USB_Out_Buffer[8], 246))
							{
								//Lectura eeprom ok
							}
							else
							{
								//Lectura eeprom Erro
							}
							seti2cOcupado(0);
 							InterrupT2_On();	
							USB_Out_Buffer[254] = 0x55;					//CRC
							NumDatos=255;
							CalcCRC(USB_Out_Buffer, NumDatos);							
							break;
						case 0x02:
						//TRAMA BORRADO EEPROM
							setpunteroWREEPROM_INI(0);
							setpunteroWREEPROM_FIN(0);
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x05;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = 0x55;					//CRC
							NumDatos=5;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
						case 0x03:
						//TRAMA LECTURA DE FECHA
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							PedirFecha();
							seti2cOcupado(0);
							InterrupT2_On();
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x0B;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = Year.byte & 0x00FF;			//AO
							USB_Out_Buffer[5] = Month.byte & 0x00FF;		//MES
							USB_Out_Buffer[6] = Day.byte & 0x00FF;			//DIA
							USB_Out_Buffer[7] = Hour.byte & 0x00FF;			//HORA
							USB_Out_Buffer[8] = Minute.byte & 0x00FF;		//MINUTO
							USB_Out_Buffer[9] = Second.byte & 0x00FF;		//SEGUNDO
							USB_Out_Buffer[10] = 0x55;						//CRC H
							NumDatos=11;
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
						case 0x04:
						//TRAMA MODIFICACIN DE FECHA
							Year.byte	=USB_In_Buffer[4];
							Month.byte	=USB_In_Buffer[5];
							Day.byte	=USB_In_Buffer[6];
							Hour.byte	=USB_In_Buffer[7];
							Minute.byte	=USB_In_Buffer[8];
							Second.byte	=USB_In_Buffer[9];
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x0B;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = Year.byte & 0x00FF;			//AO
							USB_Out_Buffer[5] = Month.byte & 0x00FF;		//MES
							USB_Out_Buffer[6] = Day.byte & 0x00FF;			//DIA
							USB_Out_Buffer[7] = Hour.byte & 0x00FF;			//HORA
							USB_Out_Buffer[8] = Minute.byte & 0x00FF;		//MINUTO
							USB_Out_Buffer[9] = Second.byte & 0x00FF;		//SEGUNDO
							USB_Out_Buffer[10] = 0x55;						//CRC H
							NumDatos=11;
							CalcCRC(USB_Out_Buffer, NumDatos);
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							ModificarFecha();
							seti2cOcupado(0);
							InterrupT2_On();
							break;
						case 0x05:
						//TRAMA LECTURA IDENTIFICADOR EQUIPO
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x15;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = ID_Datalogger0.byte & 0x00FF;		//ID_Datalogger 0
							USB_Out_Buffer[5] = ID_Datalogger1.byte & 0x00FF;		//ID_Datalogger 1
							USB_Out_Buffer[6] = ID_Datalogger2.byte & 0x00FF;		//ID_Datalogger 2
							USB_Out_Buffer[7] = ID_Datalogger3.byte & 0x00FF;		//ID_Datalogger 3
							USB_Out_Buffer[8] = ID_Datalogger4.byte & 0x00FF;		//ID_Datalogger 4
							USB_Out_Buffer[9] = ID_Datalogger5.byte & 0x00FF;		//ID_Datalogger 5
							USB_Out_Buffer[10]= ID_Datalogger6.byte & 0x00FF;		//ID_Datalogger 6
							USB_Out_Buffer[11]= ID_Datalogger7.byte & 0x00FF;		//ID_Datalogger 7
							USB_Out_Buffer[12]= ID_Datalogger8.byte & 0x00FF;		//ID_Datalogger 8
							USB_Out_Buffer[13]= ID_Datalogger9.byte & 0x00FF;		//ID_Datalogger 9
							USB_Out_Buffer[14]= ID_Datalogger10.byte & 0x00FF;	//ID_Datalogger 10
							USB_Out_Buffer[15]= ID_Datalogger11.byte & 0x00FF;	//ID_Datalogger 11
							USB_Out_Buffer[16]= ID_Datalogger12.byte & 0x00FF;	//ID_Datalogger 12
							USB_Out_Buffer[17]= ID_Datalogger13.byte & 0x00FF;	//ID_Datalogger 13
							USB_Out_Buffer[18]= ID_Datalogger14.byte & 0x00FF;	//ID_Datalogger 14
							USB_Out_Buffer[19]= ID_Datalogger15.byte & 0x00FF;	//ID_Datalogger 15
							USB_Out_Buffer[20]= 0x55;						//CRC H
							NumDatos=21;
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
						case 0x06:
						//TRAMA MODIFICACION IDENTIFICADOR EQUIPO
							ID_Datalogger0.byte	=USB_In_Buffer[4];
							ID_Datalogger1.byte	=USB_In_Buffer[5];
							ID_Datalogger2.byte	=USB_In_Buffer[6];
							ID_Datalogger3.byte	=USB_In_Buffer[7];
							ID_Datalogger4.byte	=USB_In_Buffer[8];
							ID_Datalogger5.byte	=USB_In_Buffer[9];
							ID_Datalogger6.byte	=USB_In_Buffer[10];
							ID_Datalogger7.byte	=USB_In_Buffer[11];
							ID_Datalogger8.byte	=USB_In_Buffer[12];
							ID_Datalogger9.byte	=USB_In_Buffer[13];
							ID_Datalogger10.byte	=USB_In_Buffer[14];
							ID_Datalogger11.byte	=USB_In_Buffer[15];
							ID_Datalogger12.byte	=USB_In_Buffer[16];
							ID_Datalogger13.byte	=USB_In_Buffer[17];
							ID_Datalogger14.byte	=USB_In_Buffer[18];
							ID_Datalogger15.byte	=USB_In_Buffer[19];
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x15;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = ID_Datalogger0.byte & 0x00FF;		//ID_Datalogger 0
							USB_Out_Buffer[5] = ID_Datalogger1.byte & 0x00FF;		//ID_Datalogger 1
							USB_Out_Buffer[6] = ID_Datalogger2.byte & 0x00FF;		//ID_Datalogger 2
							USB_Out_Buffer[7] = ID_Datalogger3.byte & 0x00FF;		//ID_Datalogger 3
							USB_Out_Buffer[8] = ID_Datalogger4.byte & 0x00FF;		//ID_Datalogger 4
							USB_Out_Buffer[9] = ID_Datalogger5.byte & 0x00FF;		//ID_Datalogger 5
							USB_Out_Buffer[10]= ID_Datalogger6.byte & 0x00FF;		//ID_Datalogger 6
							USB_Out_Buffer[11] = ID_Datalogger7.byte & 0x00FF;	//ID_Datalogger 7
							USB_Out_Buffer[12] = ID_Datalogger8.byte & 0x00FF;		//ID_Datalogger 0
							USB_Out_Buffer[13] = ID_Datalogger9.byte & 0x00FF;		//ID_Datalogger 1
							USB_Out_Buffer[14] = ID_Datalogger10.byte & 0x00FF;	//ID_Datalogger 2
							USB_Out_Buffer[15] = ID_Datalogger11.byte & 0x00FF;	//ID_Datalogger 3
							USB_Out_Buffer[16] = ID_Datalogger12.byte & 0x00FF;	//ID_Datalogger 4
							USB_Out_Buffer[17] = ID_Datalogger13.byte & 0x00FF;	//ID_Datalogger 5
							USB_Out_Buffer[18]= ID_Datalogger14.byte & 0x00FF;	//ID_Datalogger 6
							USB_Out_Buffer[19] = ID_Datalogger15.byte & 0x00FF;	//ID_Datalogger 7
							USB_Out_Buffer[20] = 0x55;						//CRC H
							NumDatos=21;
							CalcCRC(USB_Out_Buffer, NumDatos);
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(!SaveParametrosEEPROM_RTC(Parametros))
							{
								AveriaEEPROM_RTC=1;
							}
							seti2cOcupado(0);
							InterrupT2_On();
							break;
						case 0x07:
						//TRAMA LECTURA PARAMETRO
							USB_Out_Buffer[0] = 0x55;												//CONTROL
							USB_Out_Buffer[1] = 0x00;												//LONGITUD H
							USB_Out_Buffer[2] = 0x08;												//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;								//FUNCION
							USB_Out_Buffer[4] = USB_In_Buffer[4];									//ID PARAMETRO 
							USB_Out_Buffer[5] = (Parametros[USB_In_Buffer[4]].byte& 0xFF00) >> 8;	//VALOR PARAMETRO H
							USB_Out_Buffer[6] = Parametros[USB_In_Buffer[4]].byte & 0x00FF;			//VALOR PARAMETRO L
							USB_Out_Buffer[7] = 0x55;												//CRC H
							NumDatos=8;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
						case 0x08:
						//TRAMA MODIFICACION PARAMETRO
							Parametros[USB_In_Buffer[4]].byte=(USB_In_Buffer[5])*256 + USB_In_Buffer[6];
							USB_Out_Buffer[0] = 0x55;												//CONTROL
							USB_Out_Buffer[1] = 0x00;												//LONGITUD H
							USB_Out_Buffer[2] = 0x08;												//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;								//FUNCION
							USB_Out_Buffer[4] = USB_In_Buffer[4];									//ID PARAMETRO 
							USB_Out_Buffer[5] = (Parametros[USB_In_Buffer[4]].byte& 0xFF00) >> 8;	//VALOR PARAMETRO H
							USB_Out_Buffer[6] = Parametros[USB_In_Buffer[4]].byte & 0x00FF;			//VALOR PARAMETRO L
							USB_Out_Buffer[7] = 0x55;												//CRC H
							NumDatos=8;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(!SaveParametrosEEPROM_RTC(Parametros))
							{
								AveriaEEPROM_RTC=1;
							}
							seti2cOcupado(0);
							InterrupT2_On();
							break;
						case 0x09:
	
							break;
						case 0x0A:

							break;
					case 0x0B:
						//TRAMA RESET
							//Salvamos punteros de EEPROM y averias
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(!SavePunterosEEPROM()) 							AveriaEEPROM =1;
							if(!SaveByteControlEEPROM())						AveriaEEPROM =1;
							SaveAveriasEEPROMFun();
							seti2cOcupado(0);
							//Reset del sistema para entrar en bootloader
							asm("reset");
							break;
					case 0x0C:
						//TRAMA VERSION DE SOFTWARE
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x09;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = vSoft[0] & 0x00FF;			//vSoft 0
							USB_Out_Buffer[5] = vSoft[1] & 0x00FF;			//vSoft 1
							USB_Out_Buffer[6] = vSoft[2] & 0x00FF;			//vSoft 2
							USB_Out_Buffer[7] = vSoft[3] & 0x00FF;			//vSoft 3
							USB_Out_Buffer[8] = 0x55;						//CRC H
							NumDatos=9;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
					case 0x0D:
						//TRAMA ENTRAR MODO PROBADOR
							Estado =0xFF;
							//PROBADOR_INI=0;
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x12;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = P1_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[5] = P2_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[6] = P3_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[7] = P4_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[8] = P5_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[9] = P6_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[10] = P7_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[11] = P8_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[12] = EEPROM1_OK;
							USB_Out_Buffer[13] = EEPROM2_OK;
							USB_Out_Buffer[14] = EEPROM3_OK;
							USB_Out_Buffer[15] = 0x55;						//CRC H
							NumDatos=16;
							CalcCRC(USB_Out_Buffer, NumDatos);	
							break;
					case 0x0E:
						//TRAMA SALIR MODO PROBADOR
							Estado =0x00;
							PROBADOR_INI=0;
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x12;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = P1_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[5] = P2_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[6] = P3_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[7] = P4_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[8] = P5_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[9] = P6_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[10] = P7_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[11] = P8_NO;						//PULSADOR 1 NO
							USB_Out_Buffer[12] = EEPROM1_OK;
							USB_Out_Buffer[13] = EEPROM2_OK;
							USB_Out_Buffer[14] = EEPROM3_OK;
							USB_Out_Buffer[15] = 0x55;						//CRC H
							NumDatos=16;
							CalcCRC(USB_Out_Buffer, NumDatos);	
							break;
				case 0x0F:
						//TRAMA ALARMAS
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x07;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = Averias1.byte & 0x00FF;			//AVERIAS 1
							USB_Out_Buffer[5] = Averias2.byte & 0x00FF;			//AVERIAS 2
							USB_Out_Buffer[6] = 0x55;						//CRC H
							NumDatos=7;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
				case 0x10:
						//TRAMA BORRADO ALARMAS
							Averias1.byte=0;
							Averias2.byte=0;
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							SaveAveriasEEPROMFun();
							seti2cOcupado(0);
							InterrupT2_On();
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x07;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = Averias1.byte & 0x00FF;			//AVERIAS 1
							USB_Out_Buffer[5] = Averias2.byte & 0x00FF;			//AVERIAS 2
							USB_Out_Buffer[6] = 0x55;						//CRC H
							NumDatos=7;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
				case 0x11:
						//TRAMA POLLING
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x05;						//LONGITUD L
							USB_Out_Buffer[3] = USB_In_Buffer[3]+0x80;		//FUNCION
							USB_Out_Buffer[4] = 0x55;						//CRC H
							NumDatos=5;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
					default:
							USB_Out_Buffer[0] = 0x55;						//CONTROL
							USB_Out_Buffer[1] = 0x00;						//LONGITUD H
							USB_Out_Buffer[2] = 0x09;						//LONGITUD L
							USB_Out_Buffer[3] = 'E';
							USB_Out_Buffer[4] = 'r';
							USB_Out_Buffer[5] = 'r';
							USB_Out_Buffer[6] = 'o';
							USB_Out_Buffer[7] = 'r';
							USB_Out_Buffer[8] = 0x55;						//CRC H
							NumDatos=9;	
							CalcCRC(USB_Out_Buffer, NumDatos);
							break;
					}
					break;
				default:
						USB_Out_Buffer[0] = 0x55;						//CONTROL
						USB_Out_Buffer[1] = 0x00;						//LONGITUD H
						USB_Out_Buffer[2] = 0x09;						//LONGITUD L
						USB_Out_Buffer[3] = 'E';
						USB_Out_Buffer[4] = 'r';
						USB_Out_Buffer[5] = 'r';
						USB_Out_Buffer[6] = 'o';
						USB_Out_Buffer[7] = 'r';
						USB_Out_Buffer[8] = 0x55;						//CRC H
						NumDatos=9;	
						CalcCRC(USB_Out_Buffer, NumDatos);
						break;
			}
			putUSBUSART(USB_Out_Buffer,NumDatos);
		}

	}

    CDCTxService();
}		//end ProcessIO

/********************************************************************
 * Function:        void ProcessIO(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        This function is a place holder for other user
 *                  routines. It is a mixture of both USB and
 *                  non-USB tasks.
 *
 * Note:            None
 *******************************************************************/
void ProcessIOEth(void)
{   
    BYTE numBytesRead;
	if(getTramaUartRecivida()==1)
	{
	setTramaUartRecivida(0);
	numBytesRead = uart_rx_data(ETH_In_Buffer,64);
	//flush_uart_rx_buffer();
	if(numBytesRead != 0)
	{
		int NumDatos;
		numBytesRead=0;
		if(!CompruebaCRC(ETH_In_Buffer, ETH_In_Buffer[2]))
		{
			//Error en CRC
			ETH_In_Buffer[0]=0; //Reset del byte de control para que retorne error
		}
		switch(ETH_In_Buffer[0])
		{
			case 0xAA:
				//TRAMA CORRECTA
				switch(ETH_In_Buffer[3])
					{
						case 0x01:
							//TRAMA LECTURA EEPROM
							PaquetesTotales= CalcPaquetesEnv();
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0xFF;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = (PaquetesTotales & 0xFF00) >> 8;		//PAQUETE TOTAL H
							ETH_Out_Buffer[5] = PaquetesTotales & 0x00FF;		//PAQUETE TOTAL L
							ETH_Out_Buffer[6] = ETH_In_Buffer[4];			//PAQUETE ACTUAL H
							ETH_Out_Buffer[7] = ETH_In_Buffer[5];			//PAQUETE ACTUAL L
							if(ETH_In_Buffer[4]==0&&ETH_In_Buffer[5]==0)
							{
								//Si pide primer paquete reset de puntero de read
								setpunteroRDEEPROM(getpunteroWREEPROM_INI());
							}
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(LeerEEPROM(&ETH_Out_Buffer[8], 246))
							{
								//Lectura eeprom ok
							}
							else
							{
								//Lectura eeprom Erro
							}
							seti2cOcupado(0);
 							InterrupT2_On();	
							ETH_Out_Buffer[254] = 0x55;					//CRC
							NumDatos=255;
							CalcCRC(ETH_Out_Buffer, NumDatos);							
							break;
						case 0x02:
						//TRAMA BORRADO EEPROM
							setpunteroWREEPROM_INI(0);
							setpunteroWREEPROM_FIN(0);
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x05;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = 0x55;					//CRC
							NumDatos=5;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
						case 0x03:
						//TRAMA LECTURA DE FECHA
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							PedirFecha();
							seti2cOcupado(0);
							InterrupT2_On();
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x0B;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = Year.byte & 0x00FF;			//AO
							ETH_Out_Buffer[5] = Month.byte & 0x00FF;		//MES
							ETH_Out_Buffer[6] = Day.byte & 0x00FF;			//DIA
							ETH_Out_Buffer[7] = Hour.byte & 0x00FF;			//HORA
							ETH_Out_Buffer[8] = Minute.byte & 0x00FF;		//MINUTO
							ETH_Out_Buffer[9] = Second.byte & 0x00FF;		//SEGUNDO
							ETH_Out_Buffer[10] = 0x55;						//CRC H
							NumDatos=11;
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
						case 0x04:
						//TRAMA MODIFICACIN DE FECHA
							Year.byte	=ETH_In_Buffer[4];
							Month.byte	=ETH_In_Buffer[5];
							Day.byte	=ETH_In_Buffer[6];
							Hour.byte	=ETH_In_Buffer[7];
							Minute.byte	=ETH_In_Buffer[8];
							Second.byte	=ETH_In_Buffer[9];
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x0B;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = Year.byte & 0x00FF;			//AO
							ETH_Out_Buffer[5] = Month.byte & 0x00FF;		//MES
							ETH_Out_Buffer[6] = Day.byte & 0x00FF;			//DIA
							ETH_Out_Buffer[7] = Hour.byte & 0x00FF;			//HORA
							ETH_Out_Buffer[8] = Minute.byte & 0x00FF;		//MINUTO
							ETH_Out_Buffer[9] = Second.byte & 0x00FF;		//SEGUNDO
							ETH_Out_Buffer[10] = 0x55;						//CRC H
							NumDatos=11;
							CalcCRC(ETH_Out_Buffer, NumDatos);
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							ModificarFecha();
							seti2cOcupado(0);
							InterrupT2_On();
							break;
						case 0x05:
						//TRAMA LECTURA IDENTIFICADOR EQUIPO
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x15;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = ID_Datalogger0.byte & 0x00FF;		//ID_Datalogger 0
							ETH_Out_Buffer[5] = ID_Datalogger1.byte & 0x00FF;		//ID_Datalogger 1
							ETH_Out_Buffer[6] = ID_Datalogger2.byte & 0x00FF;		//ID_Datalogger 2
							ETH_Out_Buffer[7] = ID_Datalogger3.byte & 0x00FF;		//ID_Datalogger 3
							ETH_Out_Buffer[8] = ID_Datalogger4.byte & 0x00FF;		//ID_Datalogger 4
							ETH_Out_Buffer[9] = ID_Datalogger5.byte & 0x00FF;		//ID_Datalogger 5
							ETH_Out_Buffer[10]= ID_Datalogger6.byte & 0x00FF;		//ID_Datalogger 6
							ETH_Out_Buffer[11]= ID_Datalogger7.byte & 0x00FF;		//ID_Datalogger 7
							ETH_Out_Buffer[12]= ID_Datalogger8.byte & 0x00FF;		//ID_Datalogger 8
							ETH_Out_Buffer[13]= ID_Datalogger9.byte & 0x00FF;		//ID_Datalogger 9
							ETH_Out_Buffer[14]= ID_Datalogger10.byte & 0x00FF;	//ID_Datalogger 10
							ETH_Out_Buffer[15]= ID_Datalogger11.byte & 0x00FF;	//ID_Datalogger 11
							ETH_Out_Buffer[16]= ID_Datalogger12.byte & 0x00FF;	//ID_Datalogger 12
							ETH_Out_Buffer[17]= ID_Datalogger13.byte & 0x00FF;	//ID_Datalogger 13
							ETH_Out_Buffer[18]= ID_Datalogger14.byte & 0x00FF;	//ID_Datalogger 14
							ETH_Out_Buffer[19]= ID_Datalogger15.byte & 0x00FF;	//ID_Datalogger 15
							ETH_Out_Buffer[20]= 0x55;						//CRC H
							NumDatos=21;
							CalcCRC(ETH_Out_Buffer, NumDatos);	
							break;
						case 0x06:
						//TRAMA MODIFICACION IDENTIFICADOR EQUIPO
							ID_Datalogger0.byte	=ETH_In_Buffer[4];
							ID_Datalogger1.byte	=ETH_In_Buffer[5];
							ID_Datalogger2.byte	=ETH_In_Buffer[6];
							ID_Datalogger3.byte	=ETH_In_Buffer[7];
							ID_Datalogger4.byte	=ETH_In_Buffer[8];
							ID_Datalogger5.byte	=ETH_In_Buffer[9];
							ID_Datalogger6.byte	=ETH_In_Buffer[10];
							ID_Datalogger7.byte	=ETH_In_Buffer[11];
							ID_Datalogger8.byte	=ETH_In_Buffer[12];
							ID_Datalogger9.byte	=ETH_In_Buffer[13];
							ID_Datalogger10.byte	=ETH_In_Buffer[14];
							ID_Datalogger11.byte	=ETH_In_Buffer[15];
							ID_Datalogger12.byte	=ETH_In_Buffer[16];
							ID_Datalogger13.byte	=ETH_In_Buffer[17];
							ID_Datalogger14.byte	=ETH_In_Buffer[18];
							ID_Datalogger15.byte	=ETH_In_Buffer[19];
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x15;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = ID_Datalogger0.byte & 0x00FF;		//ID_Datalogger 0
							ETH_Out_Buffer[5] = ID_Datalogger1.byte & 0x00FF;		//ID_Datalogger 1
							ETH_Out_Buffer[6] = ID_Datalogger2.byte & 0x00FF;		//ID_Datalogger 2
							ETH_Out_Buffer[7] = ID_Datalogger3.byte & 0x00FF;		//ID_Datalogger 3
							ETH_Out_Buffer[8] = ID_Datalogger4.byte & 0x00FF;		//ID_Datalogger 4
							ETH_Out_Buffer[9] = ID_Datalogger5.byte & 0x00FF;		//ID_Datalogger 5
							ETH_Out_Buffer[10]= ID_Datalogger6.byte & 0x00FF;		//ID_Datalogger 6
							ETH_Out_Buffer[11] = ID_Datalogger7.byte & 0x00FF;	//ID_Datalogger 7
							ETH_Out_Buffer[12] = ID_Datalogger8.byte & 0x00FF;		//ID_Datalogger 0
							ETH_Out_Buffer[13] = ID_Datalogger9.byte & 0x00FF;		//ID_Datalogger 1
							ETH_Out_Buffer[14] = ID_Datalogger10.byte & 0x00FF;	//ID_Datalogger 2
							ETH_Out_Buffer[15] = ID_Datalogger11.byte & 0x00FF;	//ID_Datalogger 3
							ETH_Out_Buffer[16] = ID_Datalogger12.byte & 0x00FF;	//ID_Datalogger 4
							ETH_Out_Buffer[17] = ID_Datalogger13.byte & 0x00FF;	//ID_Datalogger 5
							ETH_Out_Buffer[18]= ID_Datalogger14.byte & 0x00FF;	//ID_Datalogger 6
							ETH_Out_Buffer[19] = ID_Datalogger15.byte & 0x00FF;	//ID_Datalogger 7
							ETH_Out_Buffer[20] = 0x55;						//CRC H
							NumDatos=21;
							CalcCRC(ETH_Out_Buffer, NumDatos);
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(!SaveParametrosEEPROM_RTC(Parametros))
							{
								AveriaEEPROM_RTC=1;
							}
							seti2cOcupado(0);
							InterrupT2_On();
							break;
						case 0x07:
						//TRAMA LECTURA PARAMETRO
							ETH_Out_Buffer[0] = 0x55;												//CONTROL
							ETH_Out_Buffer[1] = 0x00;												//LONGITUD H
							ETH_Out_Buffer[2] = 0x08;												//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;								//FUNCION
							ETH_Out_Buffer[4] = ETH_In_Buffer[4];									//ID PARAMETRO 
							ETH_Out_Buffer[5] = (Parametros[ETH_In_Buffer[4]].byte& 0xFF00) >> 8;	//VALOR PARAMETRO H
							ETH_Out_Buffer[6] = Parametros[ETH_In_Buffer[4]].byte & 0x00FF;			//VALOR PARAMETRO L
							ETH_Out_Buffer[7] = 0x55;												//CRC H
							NumDatos=8;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
						case 0x08:
						//TRAMA MODIFICACION PARAMETRO
							Parametros[ETH_In_Buffer[4]].byte=(ETH_In_Buffer[5])*256 + ETH_In_Buffer[6];
							ETH_Out_Buffer[0] = 0x55;												//CONTROL
							ETH_Out_Buffer[1] = 0x00;												//LONGITUD H
							ETH_Out_Buffer[2] = 0x08;												//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;								//FUNCION
							ETH_Out_Buffer[4] = ETH_In_Buffer[4];									//ID PARAMETRO 
							ETH_Out_Buffer[5] = (Parametros[ETH_In_Buffer[4]].byte& 0xFF00) >> 8;	//VALOR PARAMETRO H
							ETH_Out_Buffer[6] = Parametros[ETH_In_Buffer[4]].byte & 0x00FF;			//VALOR PARAMETRO L
							ETH_Out_Buffer[7] = 0x55;												//CRC H
							NumDatos=8;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(!SaveParametrosEEPROM_RTC(Parametros))
							{
								AveriaEEPROM_RTC=1;
							}
							seti2cOcupado(0);
							InterrupT2_On();
							break;
						case 0x09:
						//TRAMA LECTURA CONFIGURACION LAMPARAS
							break;
						case 0x0A:
						//TRAMA MODIFICACION CONFIGURACION LAMPARAS

							break;
					case 0x0B:
						//TRAMA RESET
							//Salvamos punteros de EEPROM y averias
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							if(!SavePunterosEEPROM()) 						AveriaEEPROM =1;
							if(!SaveByteControlEEPROM())					AveriaEEPROM =1;
							SaveAveriasEEPROMFun();
							seti2cOcupado(0);
							//Reset del sistema para entrar en bootloader
							asm("reset");
							break;
					case 0x0C:
						//TRAMA VERSION DE SOFTWARE
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x09;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = vSoft[0] & 0x00FF;			//vSoft 0
							ETH_Out_Buffer[5] = vSoft[1] & 0x00FF;			//vSoft 1
							ETH_Out_Buffer[6] = vSoft[2] & 0x00FF;			//vSoft 2
							ETH_Out_Buffer[7] = vSoft[3] & 0x00FF;			//vSoft 3
							ETH_Out_Buffer[8] = 0x55;						//CRC H
							NumDatos=9;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
					case 0x0D:
						//TRAMA ENTRAR MODO PROBADOR
							Estado =0xFF;
							//PROBADOR_INI=0;
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x12;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = P1_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[5] = P2_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[6] = P3_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[7] = P4_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[8] = P5_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[9] = P6_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[10] = P7_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[11] = P8_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[12] = EEPROM1_OK;
							ETH_Out_Buffer[13] = EEPROM2_OK;
							ETH_Out_Buffer[14] = EEPROM3_OK;
							ETH_Out_Buffer[15] = 0x55;						//CRC H
							NumDatos=16;
							CalcCRC(ETH_Out_Buffer, NumDatos);	
							break;
					case 0x0E:
						//TRAMA SALIR MODO PROBADOR
							Estado =0x00;
							PROBADOR_INI=0;
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x12;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = P1_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[5] = P2_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[6] = P3_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[7] = P4_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[8] = P5_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[9] = P6_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[10] = P7_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[11] = P8_NO;						//PULSADOR 1 NO
							ETH_Out_Buffer[12] = EEPROM1_OK;
							ETH_Out_Buffer[13] = EEPROM2_OK;
							ETH_Out_Buffer[14] = EEPROM3_OK;
							ETH_Out_Buffer[15] = 0x55;						//CRC H
							NumDatos=16;
							CalcCRC(ETH_Out_Buffer, NumDatos);	
							break;
				case 0x0F:
						//TRAMA ALARMAS
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x07;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = Averias1.byte & 0x00FF;			//AVERIAS 1
							ETH_Out_Buffer[5] = Averias2.byte & 0x00FF;			//AVERIAS 2
							ETH_Out_Buffer[6] = 0x55;						//CRC H
							NumDatos=7;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
				case 0x10:
						//TRAMA BORRADO ALARMAS
							Averias1.byte=0;
							Averias2.byte=0;
							InterrupT2_Off();
							while(geti2cOcupado());
							seti2cOcupado(1);
							SaveAveriasEEPROMFun();
							seti2cOcupado(0);
							InterrupT2_On();
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x07;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = Averias1.byte & 0x00FF;			//AVERIAS 1
							ETH_Out_Buffer[5] = Averias2.byte & 0x00FF;			//AVERIAS 2
							ETH_Out_Buffer[6] = 0x55;						//CRC H
							NumDatos=7;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
				case 0x11:
						//TRAMA POLLING
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x05;						//LONGITUD L
							ETH_Out_Buffer[3] = ETH_In_Buffer[3]+0x80;		//FUNCION
							ETH_Out_Buffer[4] = 0x55;						//CRC H
							NumDatos=5;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
				default:
							ETH_Out_Buffer[0] = 0x55;						//CONTROL
							ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
							ETH_Out_Buffer[2] = 0x09;						//LONGITUD L
							ETH_Out_Buffer[3] = 'E';
							ETH_Out_Buffer[4] = 'r';
							ETH_Out_Buffer[5] = 'r';
							ETH_Out_Buffer[6] = 'o';
							ETH_Out_Buffer[7] = 'r';
							ETH_Out_Buffer[8] = 0x55;						//CRC H
							NumDatos=9;	
							CalcCRC(ETH_Out_Buffer, NumDatos);
							break;
					}
					break;
				default:

						ETH_Out_Buffer[0] = 0x55;						//CONTROL
						ETH_Out_Buffer[1] = 0x00;						//LONGITUD H
						ETH_Out_Buffer[2] = 0x09;						//LONGITUD L
						ETH_Out_Buffer[3] = 'E';
						ETH_Out_Buffer[4] = 'r';
						ETH_Out_Buffer[5] = 'r';
						ETH_Out_Buffer[6] = 'o';
						ETH_Out_Buffer[7] = 'r';
						ETH_Out_Buffer[8] = 0x55;						//CRC H
						NumDatos=9;	
						CalcCRC(ETH_Out_Buffer, NumDatos);
						break;
			}
		
			uart_tx_data(ETH_Out_Buffer,NumDatos);
		}
		}
}		//end ProcessIO

/*********************************************************************************************
**********************************************************************************************
Nombre:            	BlinkUSBStatus
Llamadas:			interna
Funciones Ut:		LED_STATUS_Toggle, LED_STATUS_On() (HardwareProfile.h),getpunteroWREEPROM_INI()
					getpunteroWREEPROM_FIN() (eeprom.c)
Finalidad:          Se ocupa de encender/apagar led de estatus segun estado del sistema
					-Encendido Fijo (conexin USB)
					-Parpadeo Lento (Funcionalidad normal)
					-Parpadeo rapido (Mem >80%)
Argumentos:         NC
Retorno:            NC
Variables Globales: Averias1, Averias2
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void BlinkUSBStatus(void)
{
    static WORD led_count=0;
    static WORD led_count2=0; 
    
	if(led_count == 0)led_count = 40000U;
    led_count--;
	if(led_count2 == 0)led_count2 = 5000U;
    led_count2--;

	//Parpadeo Lento siempre
    if(led_count==0)	LED_STATUS_Toggle();

	//Parpadeo Rapido >80% Mem ocupada
	if (getpunteroWREEPROM_INI()>getpunteroWREEPROM_FIN())
	{
    	if(led_count2==0)	LED_STATUS_Toggle();
	}
	else
	{
		if(getpunteroWREEPROM_FIN()>51196)	//80%
		{
    		if(led_count2==0)	LED_STATUS_Toggle();
		}

	}

	//Fijo On con USB conectado
    if(USBSuspendControl == 1)
    {
		LED_STATUS_On();
    }
    else
    {
        if(USBDeviceState == DETACHED_STATE)
        {
            //LED_STATUS_Off();
        }
        else if(USBDeviceState == ATTACHED_STATE)
        {
           //LED_STATUS_On();
        }
        else if(USBDeviceState == POWERED_STATE)
        {
           //LED_STATUS_On();
        }
        else if(USBDeviceState == DEFAULT_STATE)
        {
            //LED_STATUS_Off();
        }
        else if(USBDeviceState == ADDRESS_STATE)
        {
			LED_STATUS_On();
        }
        else if(USBDeviceState == CONFIGURED_STATE)
        {
			LED_STATUS_On();
        }//end if(...)
    }//end if(UCONbits.SUSPND...)
}//end BlinkUSBStatus

/*********************************************************************************************
**********************************************************************************************
Nombre:            	BlinkAveria
Llamadas:			interna
Funciones Ut:		LED_AVERIA_On(), LED_AVERIA_Off() (HardwareProfile.h)
Finalidad:          Mira estado de los bytes de averia y enciende el led de averia segn su estado
Argumentos:         NC
Retorno:            NC
Variables Globales: Averias1, Averias2
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void BlinkAveria(void)
{
//AveriaEEPROM      Error en almenos una posicin de memoria de EEPROM de datos
//AveriaEEPROM_RTC	Error en almenos una posicin de memoria de EEPROM de parametros
//AveriaPUNTERO     Error en de almacenamiento de punteros se puede haber perdido informacin
//AveriaP1	      	Error en pulsador 1	TODO
//AveriaP2	      	Error en pulsador 2	TODO
//AveriaP3	      	Error en pulsador 3	TODO
//AveriaP4	      	Error en pulsador 4	TODO
//AveriaEEPROM_1 	
//AveriaEEPROM_2	
//AveriaEEPROM_3 	
//Averia1Pila    	
  	static WORD led_count=0;
    static WORD led_count2=0; 
    
	if(led_count == 0)led_count = 40000U;
    led_count--;
	if(led_count2 == 0)led_count2 = 5000U;
    led_count2--;

	//LED INTERMITENTE
	if(AveriaEEPROM_1  || AveriaEEPROM_2 || AveriaEEPROM_3 || AveriaEEPROM_RTC)
	{
		if(led_count2==0)	LED_AVERIA_Toggle();
	}
	else
	{
		//LED FIJO
		if(AveriaEEPROM  || AveriaPUNTERO || AveriaPila || AveriaP1 || AveriaP2 || AveriaP3 || AveriaP4 )
		{
			LED_AVERIA_On();
		}
	}

	//LED APAGADO
	if(Averias1.byte==0 && Averias2.byte==0)
	{
		LED_AVERIA_Off();
	}

 	return;
}//end BlinkAveria

/*********************************************************************************************
**********************************************************************************************
Nombre:            	Fun_Pwr_Ok
Llamadas:			external (InterruptTimer.c)
Funciones Ut:		TodoOff, geti2cOcupado,,seti2cOcupado(1),InterrupT2_Off,InterrupT1_Off,
					SavePunterosEEPROMsinComp (eeprom.c), SaveByteControlEEPROM (eeprom.c)
Finalidad:          Mira estado de entrada de control de alimentacin, en caso de que se detecte
					caida de alimentacin, mira el estado de bus i2c y procede a grabar en eeprom el
					puntero de escritura y el byte de control
Argumentos:         NC
Retorno:            BOOL 0--> el bus i2c esta ocupado 1--> No retorna
Variables Globales: NC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
BOOL Fun_Pwr_Ok(void)
{
	//PWR_OK entrada directa
	//punteroWREEPROM puntero EEPROM write
	//LED_AVERIA_Toggle();
	BOOL retorno=1;
	if(!IN_PWR_OK )
	{
		//Caida de tensin
		//ApagarTodo
		TodoOff();
		if(geti2cOcupado())
		{
			retorno=0;
		}
		else
		{
			//SalvarPunteros
			InterrupT2_Off();
			InterrupT1_Off();
			seti2cOcupado(1);
			if(!SavePunterosEEPROMsinComp())					AveriaEEPROM =1;
			if(!SaveByteControlEEPROM())						AveriaEEPROM =1;
			seti2cOcupado(0);
			while(1)
			{
				LED_AVERIA_On();
			}
		}		
	}
 	return retorno;
}//end Fun_Pwr_Ok

/*********************************************************************************************
**********************************************************************************************
Nombre:            	TodoOff
Llamadas:			interna
Funciones Ut:		LED_STATUS_Off(),LED_AVERIA_Off(),LAMPARA1_OFF(),LAMPARA2_OFF(),
					LAMPARA3_OFF(),LAMPARA4_OFF() (HardwareProfile.h)
Finalidad:          Maquina de estados de la funcionalidad del equipo
Argumentos:         NC
Retorno:            NC
Variables Globales: NC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void TodoOff(void)
{
	//ApagarTodo
	LED_STATUS_Off();
	LED_AVERIA_Off(); 
	LAMPARA1_OFF();
	LAMPARA2_OFF();
	LAMPARA3_OFF();
	LAMPARA4_OFF();
	return;
}//end TodoOff

/*********************************************************************************************
**********************************************************************************************
Nombre:            	Funcionalidad
Llamadas:			externa (\InterruptTimer.c)
Funciones Ut:		LamparasOff(),LamparasOn()
Finalidad:          Maquina de estados de la funcionalidad del equipo
Argumentos:         NC
Retorno:            NC
Variables Globales: PulsadorPulsado,Estado,PuertasCerradasF,PuertasAbiertasF,preAveriaRELE
					BYPASS
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void Funcionalidad(void)
{
	unsigned char Data,HighAdd,LowAdd;
	MyByte	ControlByte;
	switch(Estado)
    {
        case 0:
			//Estado Inicial
			LamparasOff();
			if (BYPASS)	
			{
				Estado=1;
			}
			else
			{
				Estado=2;
			}			
            break;
        case 1:
			//Estado ByPass
			if (BYPASS)
			{
				Estado=1;
				LamparasOff();
			}
				else
			{
				Estado=2;
			}
            break;	
        case 2:
			//Estado No ByPass
				if (BYPASS)
			{
				Estado=1;
				LamparasOff();
			}
				else
			{
				Estado=2;
				LamparasOn();
			}
            break;
        case 3:

            break;
    	case 4:

            break;

        case 55:
			//Estado Error Entra al inicarse por filtrados TODO
			Estado =0;
            break;
        case 255:
			//Estado Probador
			if (P1_NO == 0)	
			{	
				LAMPARA1_COLOR1();
			}
			else	
			{			
				LAMPARA1_COLOR2();
			}
			if (P2_NO == 0)	
			{	
				LAMPARA2_COLOR1();
			}
			else	
			{			
				LAMPARA2_COLOR2();
			}
			if (P3_NO == 0)	
			{	
				LAMPARA3_COLOR1();
			}
			else	
			{			
				LAMPARA3_COLOR2();
			}
			if (P4_NO == 0)	
			{	
				LAMPARA4_COLOR1();
			}
			else	
			{			
				LAMPARA4_COLOR2();
			}
			if (BYPASS==1)
			{
				LAMPARA1_COLOR1();
				LAMPARA2_COLOR2();
				LAMPARA3_COLOR1();
				LAMPARA4_COLOR2();
			}
			if (!PROBADOR_INI)
			{
				InterrupT2_Off();
				while(geti2cOcupado());
				seti2cOcupado(1);
				//----Primera EEPROM
				ControlByte.byte=K_Control_M0_B1;
				//Primer modulo eeprom
				//Segundo bloque eeprom
				HighAdd=ADDR_PRUEBA_EEPROM_H;
				LowAdd=ADDR_PRUEBA_EEPROM_L;
				Data=0xFF;
				EEPROM1_OK=SaveByteEEPROM(ControlByte,HighAdd,LowAdd,Data);	
				Data=0x55;
				EEPROM1_OK=SaveByteEEPROM(ControlByte,HighAdd,LowAdd,Data);	
				//----Segunda EEPROM
				ControlByte.byte=K_Control_M1_B1;
				HighAdd=ADDR_PRUEBA_EEPROM_H;
				LowAdd=ADDR_PRUEBA_EEPROM_L;
				Data=0xFF;
				EEPROM2_OK=SaveByteEEPROM(ControlByte,HighAdd,LowAdd,Data);	
				Data=0x55;
				EEPROM2_OK=SaveByteEEPROM(ControlByte,HighAdd,LowAdd,Data);	
				//----Tercera EEPROM
				ControlByte.byte=0xA0;
				ControlByte.byte=K_Control_M2_B1;
				HighAdd=ADDR_PRUEBA_EEPROM_H;
				LowAdd=ADDR_PRUEBA_EEPROM_L;
				Data=0xFF;
				EEPROM3_OK=SaveByteEEPROM(ControlByte,HighAdd,LowAdd,Data);	
				Data=0x55;
				EEPROM3_OK=SaveByteEEPROM(ControlByte,HighAdd,LowAdd,Data);	
				seti2cOcupado(0);
				InterrupT2_On();
				PROBADOR_INI=1;
			}
            break;
	}
	return;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	TrataPuls
Llamadas:			interna
Funciones Ut:		NC
Finalidad:          Mira que pulsador a sido pulsado a traves de los flancos
					y rellena los valores de pulsadorPulsado y colorPulsaso
Argumentos:         NC
Retorno:            NC
Variables Globales: P1_NO,P2_NO,P3_NO,P4_NO,pulsadorPulsado,colorPulsado,
					ColorLampara1,ColorLampara2,ColorLampara3,ColorLampara4
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void  TrataPuls(void)
{ 

	if(P1_NO)		
	{
		pulsadorPulsado.byte=1;	
		colorPulsado.byte=ColorLampara1;
	}
	else if(P2_NO)	
	{
		pulsadorPulsado.byte=2;	
		colorPulsado.byte=ColorLampara2;
	}
	else if(P3_NO)	
	{
		pulsadorPulsado.byte=3;	
		colorPulsado.byte=ColorLampara3;
	}
	else if(P4_NO)	
	{
		pulsadorPulsado.byte=4;
		colorPulsado.byte=ColorLampara4;	
	}
	else
	{
		pulsadorPulsado.byte=0;
		colorPulsado.byte=0;
	}
	return;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	DeteccionFlancos
Llamadas:			interna
Funciones Ut:		NC
Finalidad:          Detectar Flancos de subida y bajada de las seales de entradas filtradas
					solo para Pulsadores NO, Rele y byPass
Argumentos:         NC
Retorno:            NC
Variables Globales: P1_NO,P2_NO,P3_NO,P4_NO,P1_NC,P2_NC,P3_NC,P4_NC,RELE,BYPASS
					FS_P1_NO,FB_P1_NO,FS_P2_NO,FB_P2_NO,FS_P3_NO,FB_P3_NO,FS_P4_NO,FB_P4_NO
					FS_RELE,FB_RELE,FS_BYPASS,FB_BYPASS
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void  DeteccionFlancos(void)
{ 
	//DETECCION DE FLANCOS DE LA SEAL FILTRADA
	FS_P1_NO=0;
	FS_P2_NO=0;
	FS_P3_NO=0;
	FS_P4_NO=0;
	FB_P1_NO=0;
	FB_P2_NO=0;
	FB_P3_NO=0;
	FB_P4_NO=0;
	FS_BYPASS=0;
	FB_BYPASS=0;
	//PULSADOR 1 NO
	if (P1_NO&&!P1_NO_ANT)
	{
		FS_P1_NO=1;
		P1_NO_ANT=1;
	}
	else if(!P1_NO&&P1_NO_ANT)
	{
		FB_P1_NO=1;
		P1_NO_ANT=0;
	}
	//PULSADOR 2 NO
	if (P2_NO&&!P2_NO_ANT)
	{
		FS_P2_NO=1;
		P2_NO_ANT=1;
	}
	else if(!P2_NO&&P2_NO_ANT)
	{
		FB_P2_NO=1;
		P2_NO_ANT=0;
	}
	//PULSADOR 3 NO
	if (P3_NO&&!P3_NO_ANT)
	{
		FS_P3_NO=1;
		P3_NO_ANT=1;
	}
	else if(!P3_NO&&P3_NO_ANT)
	{
		FB_P3_NO=1;
		P3_NO_ANT=0;
	}
	//PULSADOR 4 NO
	if (P4_NO&&!P4_NO_ANT)
	{
		FS_P4_NO=1;
		P4_NO_ANT=1;
	}
	else if(!P4_NO&&P4_NO_ANT)
	{
		FB_P4_NO=1;
		P4_NO_ANT=0;
	}
	//BYPASS
	if (BYPASS&&!BYPASS_ANT)
	{
		FS_BYPASS=1;
		BYPASS_ANT=1;
	}
	else if(!BYPASS&&BYPASS_ANT)
	{
		FB_BYPASS=1;
		BYPASS_ANT=0;
	}
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	FiltrarInputs
Llamadas:			externa (\InterruptTimer.c)
Funciones Ut:		NC
Finalidad:          Leer Entradas directas y filtrar
Argumentos:         NC
Retorno:            NC
Variables Globales: P1_NO,P2_NO,P3_NO,P4_NO,BYPASS
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void  FiltrarInputs(void)
{ 
	//Filtramos entradas y pasamos a booleanos
	#define flt_pulsadores			10
	#define flt_rele				10
	#define flt_bypass				10
	#define flt_puertas				200

	static unsigned cnt_P1_NO, cnt_P2_NO, cnt_P3_NO,cnt_P4_NO, cnt_BYPASS;
	static BOOL 	IN_P1_NO_ANT,IN_P2_NO_ANT,IN_P3_NO_ANT,IN_P4_NO_ANT,IN_BYPASS_ANT;
	//FILTRADOS ENTRADAS DIGITALES-----------------------------------------
	//PULSADOR 1 N0
	if(IN_P1_NO && !IN_P1_NO_ANT)		//Flanco SUBIDA
	{
		IN_P1_NO_ANT=1;
		cnt_P1_NO=0;
	}
	if(!IN_P1_NO && IN_P1_NO_ANT)		//Flanco BAJADA
	{
		IN_P1_NO_ANT=0;
		cnt_P1_NO=flt_pulsadores;
	}
	if(IN_P1_NO)		
	{
		if(cnt_P1_NO==flt_pulsadores)	P1_NO=1;
		else							cnt_P1_NO++;

	}
	else 
	{
		if(cnt_P1_NO==0)				P1_NO=0;
		else							cnt_P1_NO--;
	}
	//PULSADOR 2 N0
	if(IN_P2_NO && !IN_P2_NO_ANT)		//Flanco SUBIDA
	{
		IN_P2_NO_ANT=1;
		cnt_P2_NO=0;
	}
	if(!IN_P2_NO && IN_P2_NO_ANT)		//Flanco BAJADA
	{
		IN_P2_NO_ANT=0;
		cnt_P2_NO=flt_pulsadores;
	}
	if(IN_P2_NO)		
	{
		if(cnt_P2_NO==flt_pulsadores)	P2_NO=1;
		else							cnt_P2_NO++;

	}
	else 
	{
		if(cnt_P2_NO==0)				P2_NO=0;
		else							cnt_P2_NO--;
	}
	//PULSADOR 3 N0
	if(IN_P3_NO && !IN_P3_NO_ANT)		//Flanco SUBIDA
	{
		IN_P3_NO_ANT=1;
		cnt_P3_NO=0;
	}
	if(!IN_P3_NO && IN_P3_NO_ANT)		//Flanco BAJADA
	{
		IN_P3_NO_ANT=0;
		cnt_P3_NO=flt_pulsadores;
	}
	if(IN_P3_NO)		
	{
		if(cnt_P3_NO==flt_pulsadores)	P3_NO=1;
		else							cnt_P3_NO++;

	}
	else 
	{
		if(cnt_P3_NO==0)				P3_NO=0;
		else							cnt_P3_NO--;
	}
	//PULSADOR 4 N0
	if(IN_P4_NO && !IN_P4_NO_ANT)		//Flanco SUBIDA
	{
		IN_P4_NO_ANT=1;
		cnt_P4_NO=0;
	}
	if(!IN_P4_NO && IN_P4_NO_ANT)		//Flanco BAJADA
	{
		IN_P4_NO_ANT=0;
		cnt_P4_NO=flt_pulsadores;
	}
	if(IN_P4_NO)		
	{
		if(cnt_P4_NO==flt_pulsadores)	P4_NO=1;
		else							cnt_P4_NO++;

	}
	else 
	{
		if(cnt_P4_NO==0)				P4_NO=0;
		else							cnt_P4_NO--;
	}

	//BYPASS
	if(IN_BYPASS && !IN_BYPASS_ANT)		//Flanco SUBIDA
	{
		IN_BYPASS_ANT=1;
		cnt_BYPASS=0;
	}
	if(!IN_BYPASS && IN_BYPASS_ANT)		//Flanco BAJADA
	{
		IN_BYPASS_ANT=0;
		cnt_BYPASS=flt_pulsadores;
	}
	if(IN_BYPASS)		
	{
		if(cnt_BYPASS==flt_pulsadores)	BYPASS=1;
		else							cnt_BYPASS++;

	}
	else 
	{
		if(cnt_BYPASS==0)					BYPASS=0;
		else							cnt_BYPASS--;
	}

	return;
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	LamparasOn
Llamadas:			interna
Funciones Ut:		LAMPARA1_OFF,LAMPARA2_OFF,LAMPARA3_OFF,LAMPARA4_OFF,
					LAMPARA1_COLOR1(),LAMPARA1_COLOR2(),LAMPARA2_COLOR1(),LAMPARA2_COLOR2()(HardwareProfile.h)
					LAMPARA3_COLOR1(),LAMPARA3_COLOR2(),LAMPARA4_COLOR1(),LAMPARA4_COLOR2()(HardwareProfile.h)
Finalidad:          Encargada de Encender las lamparas de los pulsadores adecuadamente segun variables
Argumentos:         NC
Retorno:            NC
Variables Globales: Lampara1, Lampara2, Lampara3, ColorLampara1, ColorLampara2, ColorLampara3, ColorLampara4
					Lampara1Salida1,Lampara1Salida2,Lampara2Salida1,Lampara2Salida2,Lampara3Salida1,Lampara3Salida2
					Lampara4Salida1,Lampara4Salida2
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void  LamparasOn(void)
{ 
//Outputs Lamparas
//Pueden coger valores 00, 01, 10 Apagado, Color 1, Color 2
//unsigned char Lampara1;
//unsigned char Lampara2;
//unsigned char Lampara3;
//unsigned char Lampara4;
//Pueden coger valores 
//00 Sin configurar
//01 Fijo Sentido 1 01 salida, 
//10 Fijo Sentido 2 10 Salida
//11 Aleatorio
	if (P1_NO == 0)	
	{	
		LAMPARA1_COLOR1();
		ColorLampara1=1;
	}
	else	
	{			
		LAMPARA1_COLOR2();
		ColorLampara1=2;
	}

	if (P2_NO == 0)	
	{	
		LAMPARA2_COLOR1();
		ColorLampara2=1;
	}
	else	
	{			
		LAMPARA2_COLOR2();
		ColorLampara2=2;
	}

	if (P3_NO == 0)	
	{	
		LAMPARA3_COLOR1();
		ColorLampara3=1;
	}
	else	
	{			
		LAMPARA3_COLOR2();
		ColorLampara3=2;
	}

	if (P4_NO == 0)	
	{	
		LAMPARA4_COLOR1();
		ColorLampara4=1;
	}
	else	
	{			
		LAMPARA4_COLOR2();
		ColorLampara4=2;
	}

	return;
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	LamparasOff
Llamadas:			interna
Funciones Ut:		LAMPARA1_OFF,LAMPARA1_OFF,LAMPARA1_OFF,LAMPARA1_OFF (HardwareProfile.h)
Finalidad:          Encargada de Apagar las lamparas de los pulsadores
Argumentos:         NC
Retorno:            NC
Variables Globales: Lampara1, Lampara2, Lampara3, ColorLampara1, ColorLampara2, ColorLampara3, ColorLampara4
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void  LamparasOff(void)
{ 
	Lampara1=0;
	Lampara2=0;
	Lampara3=0;
	Lampara4=0;
	ColorLampara1= 0;
	ColorLampara2= 0;
	ColorLampara3= 0;
	ColorLampara4= 0;
	LAMPARA1_OFF();
	LAMPARA2_OFF();
	LAMPARA3_OFF();
	LAMPARA4_OFF();
	return;
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	PedirFecha
Llamadas:			interna
Funciones Ut:		i2c_rtcc_rd (i2c_rtcc_func.c)
Finalidad:          Lee los valores de Time Keaper de fecha y almacena en variables globales
Argumentos:         NC
Retorno:            BOOL 1
Variables Globales: Year, Month, Day, Hour, Minute, Second, ADDR_YEAR, ADDR_MNTH, ADDR_DATE, ADDR_HOUR, 
					ADDR_MIN, ADDR_SEC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
BOOL	PedirFecha(void)
{
	BOOL retorno=0;
	retorno=1;
	Year.byte =BCD2BIN(i2c_rtcc_rd(ADDR_YEAR));  					// read YEAR     
	Month.byte = BCD2BIN(i2c_rtcc_rd(ADDR_MNTH) & (~LP));  			// read MONTH 
	Day.byte = BCD2BIN(i2c_rtcc_rd(ADDR_DATE));  					// read DATE 
	Hour.byte  = BCD2BIN(i2c_rtcc_rd(ADDR_HOUR));  					// read HOUR
	Minute.byte= BCD2BIN(i2c_rtcc_rd(ADDR_MIN));  					// read MIN
    Second.byte= BCD2BIN(i2c_rtcc_rd(ADDR_SEC)& (~START_32KHZ));	// read SEC 
 	return retorno;
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	ModificarFecha
Llamadas:			interna
Funciones Ut:		i2c_rtcc_wr (i2c_rtcc_func.c)
Finalidad:          Envia nuevos valores de Fecha al Time Keaper llamando a funciones de wr de i2c
Argumentos:         NC
Retorno:            BOOL 1
Variables Globales: Year, Month, Day, Hour, Minute, Second, ADDR_YEAR, ADDR_MNTH, ADDR_DATE, ADDR_HOUR, 
					ADDR_MIN, ADDR_SEC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
BOOL	ModificarFecha(void)
{
	BOOL retorno=0;

	retorno=1;
 //extern unsigned char err_flg                  ;  // 
	i2c_rtcc_wr(ADDR_YEAR,BIN2BCD(Year.byte));   				// update YEAR    value in RTCC
	i2c_rtcc_wr(ADDR_MNTH,BIN2BCD(Month.byte));   				// update MONTH   value in RTCC
                                      							// LP bit is read only; you may clear it. 
	i2c_rtcc_wr(ADDR_DATE,BIN2BCD(Day.byte));   				// update DATE    value in RTCC
	i2c_rtcc_wr(ADDR_HOUR,BIN2BCD(Hour.byte));   				// update HOUR    value in RTCC                
	i2c_rtcc_wr(ADDR_MIN,BIN2BCD(Minute.byte));   				// update MINUTES value in RTCC
	i2c_rtcc_wr(ADDR_SEC,BIN2BCD(Second.byte)| START_32KHZ);   	// update SECONDS value in RTCC   
  	return retorno;

}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	CalcPaquetesEnv
Llamadas:			interna
Funciones Ut:		getpunteroWREEPROM_INI, getpunteroWREEPROM_FIN (eeprom.c)
Finalidad:          Calcula en numero de tramas que se necesita enviar para enviar todos los eventos
					almacenados en EEPROM
Argumentos:         NC
Retorno:            Paquetes int --> Nmero de tramas calculado
Variables Globales: NC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
unsigned int CalcPaquetesEnv(void)
{
#define maximospaquetes 1017

	unsigned int Paquetes;
	if(getpunteroWREEPROM_INI()==getpunteroWREEPROM_FIN())
	{
		//No hay datos
		Paquetes = 0;
	}
	if(getpunteroWREEPROM_INI()==0)
	{
		//No se ha dado la vuelta
		Paquetes=getpunteroWREEPROM_FIN()/41;
	}
	if(getpunteroWREEPROM_INI()!=0)
	{
		//Se ha dado la vuelta
		Paquetes=maximospaquetes;
	}
	return Paquetes;

}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	CalcCRC
Llamadas:			interna
Funciones Ut:		NC
Finalidad:          Calcula CRC de buffer y lo incluye en el ultimo elemento buffer
Argumentos:         buffer[] char, longitud int
Retorno:            NC
Variables Globales: NC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void CalcCRC(unsigned char buffer[], unsigned int longitud)
{
	unsigned char crc = 0;
	int i;
	for (i=0; i<longitud-1; i++)
	{
		crc = crc ^ buffer[i];
	}	
	buffer[longitud-1] = crc;
	return;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	CompruebaCRC
Llamadas:			interna
Funciones Ut:		NC
Finalidad:          Comprueba si CRC de buffer es correcto XOR de 0-(n-1)
Argumentos:         buffer[] char, longitud int
Retorno:            BOOL 1--> CRC Correcto, 0--> CRC Incorrecto
Variables Globales: NC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
BOOL CompruebaCRC(unsigned char buffer[], unsigned int longitud)
{
	BOOL retorno;
	unsigned char crc = 0;
	int i;
	for (i=0; i<longitud-1; i++)
	{
		crc = crc ^ buffer[i];
	}
	if(	buffer[longitud-1]== crc) 	retorno = 1;
	else 							retorno = 0;

	return retorno;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	SaveEventosRAM
Llamadas:			externa InterrupTimer.c	
Funciones Ut:		SincronizaDecimas (funcionalidad.c), DeteccionFlancos (funcionalidad.c), SaveEventoRAM (funcionalidad.c),PedirFecha (funcionalidad.c)
Finalidad:          Si hay flancos de entradas detectados llama a SaveEventoRAM con el valor adecuado para guarar evento
Argumentos:         NC
Retorno:            NC
Variables Globales: PulsadorPulsado, pulsadorPulsado, colorPulsado, Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion
					FS_P1_NO, FS_P2_NO, FS_P3_NO, FB_P4_NO, FB_P1_NO, FB_P2_NO, FB_P3_NO, FB_P4_NO, FS_BYPASS, FB_BYPASS
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void SaveEventosRAM(void)
{
	SincronizaDecimas();
	DeteccionFlancos();
	if(FS_P1_NO)
	{
		PulsadorPulsado=1;
		//TrataPuls();
		pulsadorPulsado.byte=1;	
		colorPulsado.byte=ColorLampara1;
		//Decima de segundo
		PedirFecha();
		Decima.byte=getdSecond();
		NumEntrada.byte=1;
		Codificacion.byte=colorPulsado.byte<<1;
		Codificacion.bit0=1;	//ON
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FS_P2_NO)
	{
		PulsadorPulsado=1;
		PedirFecha();
		//TrataPuls();
		pulsadorPulsado.byte=2;	
		colorPulsado.byte=ColorLampara2;
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=2;
		Codificacion.byte=colorPulsado.byte<<1;
		Codificacion.bit0=1;	//ON
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FS_P3_NO)
	{
		PulsadorPulsado=1;
		PedirFecha();
		//TrataPuls();
		pulsadorPulsado.byte=3;	
		colorPulsado.byte=ColorLampara3;
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=3;
		Codificacion.byte=colorPulsado.byte<<1;
		Codificacion.bit0=1;	//ON
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FS_P4_NO)
	{
		PulsadorPulsado=1;
		PedirFecha();
		//TrataPuls();
		pulsadorPulsado.byte=4;	
		colorPulsado.byte=ColorLampara4;
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=4;
		Codificacion.byte=colorPulsado.byte<<1;
		Codificacion.bit0=1;	//ON
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FB_P1_NO)
	{
		PedirFecha();
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=1;
		Codificacion.byte=0;
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FB_P2_NO)
	{
		PedirFecha();
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=2;
		Codificacion.byte=0;
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FB_P3_NO)
	{
		PedirFecha();
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=3;
		Codificacion.byte=0;
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FB_P4_NO)
	{
		PedirFecha();
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=4;
		Codificacion.byte=0;
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FS_BYPASS)
	{
		PedirFecha();
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=5;
		Codificacion.byte=1;
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	if(FB_BYPASS)
	{
		PedirFecha();
		//Decima de segundo
		Decima.byte=getdSecond();
		NumEntrada.byte=5;
		Codificacion.byte=0;
		SaveEventoRAM(Day, Month, Year, Hour, Minute, Second, Decima, NumEntrada, Codificacion);
	}
	return;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	SincronizaDecimas
Llamadas:			interna	
Funciones Ut:		BCD2BIN funcionalidad.c
Finalidad:          Sincronizar decimas de segundo si el segundo de timekeaper ha cambiado
Argumentos:         NC
Retorno:            NC
Variables Globales: MyByte Second, MyByte Second_ANT
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void SincronizaDecimas(void)
{
   	Second.byte= BCD2BIN(i2c_rtcc_rd(ADDR_SEC)& (~START_32KHZ));	// read regundo
	if(Second.byte!=Second_ANT.byte)
	{
		setdSecond(0);
		setmSecond(0);
		Second_ANT=Second;
	}
	return;
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	AddEventoRAM
Llamadas:			interna	
Funciones Ut:		NC
Finalidad:          Aadir nuevo Evento a buffer de Eventos RAM
Argumentos:         MyByte byte1-byte6 de Eventos
Retorno:            Booleano 1-->OK 0-->buffer RAM lleno
Variables Globales: Eventos[] Buffer de eventos RAM, cntEnevtos numero de eventos en RAM, MAXEVENTOSRAM, indexEventos_FIN
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
BOOL AddEventoRAM(MyByte byte1, MyByte  byte2, MyByte  byte3, MyByte  byte4, MyByte  byte5, MyByte  byte6)
{
	BOOL retorno;
	retorno = 1;

	if (cntEventos >= MAXEVENTOSRAM)		//BUFFER LLENO
	{
		retorno = 0;
		return retorno;	
	}
	Eventos[indexEventos_FIN][0]=byte1;
	Eventos[indexEventos_FIN][1]=byte2;
	Eventos[indexEventos_FIN][2]=byte3;
	Eventos[indexEventos_FIN][3]=byte4;
	Eventos[indexEventos_FIN][4]=byte5;
	Eventos[indexEventos_FIN][5]=byte6;
	cntEventos++;
	if (indexEventos_FIN == MAXEVENTOSRAM-1) 	indexEventos_FIN=0;
	else 									indexEventos_FIN++;

	return retorno;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:        		SaveEventosEEPROM
Llamadas:			Interna
Funciones Ut:		SaveEventoEEPROM(eeprom.c)		
Finalidad:          Funcin encaragada de coger los Eventos del Buffer de ram y llamar a SaveEventoEEPROM
					vacia buffer de RAM
Argumentos:         NC
Retorno:            Booleano 1-->SaveEventoEEPROM OK 0-->SaveEventoEEPROM ERR
Variables Globales: Eventos[] Buffer de eventos RAM, cntEnevtos numero de eventos en RAM, AveriaEEPROM, indexEventos_INI
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
BOOL SaveEventosEEPROM(void)
{
	unsigned int i;
	unsigned int cntEventosLocal;
	BOOL retorno=1;
	cntEventosLocal=cntEventos;
	for (i=0; i<cntEventosLocal;i++)
	{
		if(!SaveEventoEEPROM(Eventos[indexEventos_INI][0], Eventos[indexEventos_INI][1], Eventos[indexEventos_INI][2], Eventos[indexEventos_INI][3], Eventos[indexEventos_INI][4],Eventos[indexEventos_INI][5]))
		{
			AveriaEEPROM=1;
			retorno=0;
		}
		cntEventos--;
		if (indexEventos_INI == MAXEVENTOSRAM-1) 	indexEventos_INI=0;
		else 										indexEventos_INI++;
	}
	return retorno;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:        		SaveEventoRAM
Llamadas:			Interna
Funciones Ut:		AddEventoRAM(funcionalidad.c)	
Finalidad:          Funcin encargada de codificar datos de fecha y llamar a AddEventoRAM
Argumentos:         MyByte day, month, year, hour, minute, second, msecond, NumEntrada, Codificacin
Retorno:            NC
Variables Globales: NC
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void SaveEventoRAM(MyByte day, MyByte month, MyByte year, MyByte hour, MyByte minute, MyByte second, MyByte msecond, MyByte NumEntrada, MyByte Codificacion)
{ 
	//Se debe grabar fecha, color de pulsador y nuemro pulsador
	//Dia,Mes,Ao,Hora,Minuto,Segundo,Color pulsador 0-4,Numero Pulsador 0-4
	MyByte Data[6];
	//Comprimimos los datos D:Dia,M:Mes,A:Ao,H:Hora,m:Minuto,S:Segundo,C:Color,P:Pulsador,R:Reserva
	//BYTE 1
	//	D4		D3		D2		D1		D0		M3		M2		M1
	//BYTE 2
	//	M0		A6		A5		A4		A3		A2		A1		A0
	//BYTE 3
	//	H4		H3		H2		H1		H0		m5		m4		m3
	//BYTE 4
	//	m2		m1		m0		S5		S4		S3		S2		S1
	//BYTE 5
	//	S0		ms3		ms2		ms1		ms0		N2		N1		N0
	//BYTE 6
	//	C3		C2		C1		C0		R3		R2		R1		R0
	//Convertimos datos a 6 Bytes
	Data[0].bit7=day.bit4;
	Data[0].bit6=day.bit3;
	Data[0].bit5=day.bit2;
	Data[0].bit4=day.bit1;
	Data[0].bit3=day.bit0;
	Data[0].bit2=month.bit3;
	Data[0].bit1=month.bit2;
	Data[0].bit0=month.bit1;

	Data[1].bit7=month.bit0;
	Data[1].bit6=year.bit6;
	Data[1].bit5=year.bit5;
	Data[1].bit4=year.bit4;
	Data[1].bit3=year.bit3;
	Data[1].bit2=year.bit2;
	Data[1].bit1=year.bit1;
	Data[1].bit0=year.bit0;

	Data[2].bit7=hour.bit4;
	Data[2].bit6=hour.bit3;
	Data[2].bit5=hour.bit2;
	Data[2].bit4=hour.bit1;
	Data[2].bit3=hour.bit0;
	Data[2].bit2=minute.bit5;
	Data[2].bit1=minute.bit4;
	Data[2].bit0=minute.bit3;

	Data[3].bit7=minute.bit2;
	Data[3].bit6=minute.bit1;
	Data[3].bit5=minute.bit0;
	Data[3].bit4=second.bit5;
	Data[3].bit3=second.bit4;
	Data[3].bit2=second.bit3;
	Data[3].bit1=second.bit2;
	Data[3].bit0=second.bit1;

	Data[4].bit7=second.bit0;
	Data[4].bit6=msecond.bit3;
	Data[4].bit5=msecond.bit2;
	Data[4].bit4=msecond.bit1;
	Data[4].bit3=msecond.bit0;
	Data[4].bit2=NumEntrada.bit2;
	Data[4].bit1=NumEntrada.bit1;
	Data[4].bit0=NumEntrada.bit0;

	Data[5].bit7=Codificacion.bit3;
	Data[5].bit6=Codificacion.bit2;
	Data[5].bit5=Codificacion.bit1;
	Data[5].bit4=Codificacion.bit0;;
	Data[5].bit3=0;
	Data[5].bit2=0;
	Data[5].bit1=0;
	Data[5].bit0=0;

	AddEventoRAM(Data[0], Data[1], Data[2], Data[3], Data[4], Data[5]);
	return;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:        		SaveAveriasEEPROMFun(void)	
Llamadas:			externa, eeprom.c
Funciones Ut:		SaveAveriasEEPROM (eeprom.c)
Finalidad:          Funcin encargada de llamar a SaveAveriasEEPROM de eeprom.c basicamente
					para poder llamar a la funcion dsd interrupTimer.c
Argumentos:         NC
Retorno:            NC
Variables Globales: Averias1, Averias2, AveriaEEPROM
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
void SaveAveriasEEPROMFun(void)
{ 
	if(!SaveAveriasEEPROM(Averias1, Averias2))		AveriaEEPROM =1;
	return;
}
							
/*********************************************************************************************
**********************************************************************************************
Nombre:          	geti2cOcupado(void)
Llamadas:			externa, InterrupTimer.c
Funciones Ut:		NC
Finalidad:          Obtener valor Variable Global i2cOcupado para saber si i2c esta ocupado
Argumentos:         NC
Retorno:            booleano i2cOcupado
Variables Globales: i2cOcupado
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/

BOOL geti2cOcupado(void)
{ 
	return i2cOcupado;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	seti2cOcupado(BOOL valor)
Llamadas:			externa, InterrupTimer.c	
Funciones Ut:		NC
Finalidad:          Colocar Variable Global i2cOcupado 1 o 0 para indicar que i2c esta ocupado
Argumentos:         valor => Booleano para actualizar i2cOcupado
Retorno:            NC
Variables Globales: i2cOcupado
Autor Fecha:        Luis Alvarez 25/04/13
Historial:          NC
*********************************************************************************************/
 void seti2cOcupado(BOOL valor)
{ 
	i2cOcupado = valor;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	calcCombLamparas()
Llamadas:			interna	
Funciones Ut:		NC
Finalidad:          Calcular Combinaciones Validas de Pulsadores
Argumentos:         NC
Retorno:            NC
Variables Globales: Lampara1Salida1,Lampara1Salida2,Lampara2Salida1,Lampara2Salida2,Lampara3Salida1,Lampara3Salida2 (MyByte)
Autor Fecha:        Luis Alvarez 07/03/13
Historial:          NC
*********************************************************************************************/
 void calcCombLamparas()
{ 
	unsigned char 	CombLamparasAux[4];
	MyByte			SalidasCombLamparasAux;
	cntCombValidas=0;
	//TODO comprobar que no se repitan combinaciones
	//000
	CombLamparasAux[0]=Lampara1Salida1.byte;
	CombLamparasAux[1]=Lampara2Salida1.byte;
	CombLamparasAux[2]=Lampara3Salida1.byte;
	SalidasCombLamparasAux.byte=0;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//001
	CombLamparasAux[0]=Lampara1Salida2.byte;
	CombLamparasAux[1]=Lampara2Salida1.byte;
	CombLamparasAux[2]=Lampara3Salida1.byte;
	SalidasCombLamparasAux.byte=1;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//010
	CombLamparasAux[0]=Lampara1Salida1.byte;
	CombLamparasAux[1]=Lampara2Salida2.byte;
	CombLamparasAux[2]=Lampara3Salida1.byte;
	SalidasCombLamparasAux.byte=2;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//011
	CombLamparasAux[0]=Lampara1Salida2.byte;
	CombLamparasAux[1]=Lampara2Salida2.byte;
	CombLamparasAux[2]=Lampara3Salida1.byte;
	SalidasCombLamparasAux.byte=3;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//100
	CombLamparasAux[0]=Lampara1Salida1.byte;
	CombLamparasAux[1]=Lampara2Salida1.byte;
	CombLamparasAux[2]=Lampara3Salida2.byte;
	SalidasCombLamparasAux.byte=4;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//101
	CombLamparasAux[0]=Lampara1Salida2.byte;
	CombLamparasAux[1]=Lampara2Salida1.byte;
	CombLamparasAux[2]=Lampara3Salida2.byte;
	SalidasCombLamparasAux.byte=5;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//110
	CombLamparasAux[0]=Lampara1Salida1.byte;
	CombLamparasAux[1]=Lampara2Salida2.byte;
	CombLamparasAux[2]=Lampara3Salida2.byte;
	SalidasCombLamparasAux.byte=6;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	//111
	CombLamparasAux[0]=Lampara1Salida2.byte;
	CombLamparasAux[1]=Lampara2Salida2.byte;
	CombLamparasAux[2]=Lampara3Salida2.byte;
	SalidasCombLamparasAux.byte=7;
	PruebaComb(CombLamparasAux,SalidasCombLamparasAux);
	return;
}

/*********************************************************************************************
**********************************************************************************************
Nombre:            	PruebaComb(unsigned char CombLamparasAux[4])
Llamadas:			interna	
Funciones Ut:		NC
Finalidad:          Verifica que combinaciones son validas
Argumentos:         unsigned char CombLamparasAux[4]
Retorno:            NC
Variables Globales: cntCombValidas,CombLamparas1[],CombLamparas2[],CombLamparas3[]
Autor Fecha:        Luis Alvarez 07/03/13
Historial:          NC
*********************************************************************************************/
void PruebaComb(unsigned char CombLamparasAux[4],MyByte SalidasCombLamparasAux)
{ 
//unsigned char CombLamparas1[4];
//unsigned char CombLamparas2[4];
//unsigned char CombLamparas3[4];
	unsigned int 	i;
	//Validar Combinacin 
	if(ValidaComb(CombLamparasAux))
	{
		//Combinacin Valida
		if (cntCombValidas==0)	
		{
			for(i=0;i<4;i++)
			{
				CombLamparas1[i]=CombLamparasAux[i];
			}
			SalidasCombLamparas1=SalidasCombLamparasAux;
		}
		if (cntCombValidas==1)	
		{
			for(i=0;i<4;i++)
			{
				CombLamparas2[i]=CombLamparasAux[i];
			}
			SalidasCombLamparas2=SalidasCombLamparasAux;
		}
		if (cntCombValidas==2)	
		{
			for(i=0;i<4;i++)
			{
				CombLamparas3[i]=CombLamparasAux[i];
			}
			SalidasCombLamparas3=SalidasCombLamparasAux;
		}
		cntCombValidas++;
	}
	return;
}
/*********************************************************************************************
**********************************************************************************************
Nombre:            	ValidaComb(unsigned char comb[4])
Llamadas:			interna	
Funciones Ut:		NC
Finalidad:          Valida si una cambinacin de lamparas es valida
Argumentos:         unsigned char comb[4]
Retorno:            BOOL 1->Combinacion Valida 0->Combinacion No Valida
Variables Globales: cntCombValidas,CombLamparas1[],CombLamparas2[],CombLamparas3[]
Autor Fecha:        Luis Alvarez 07/03/13
Historial:          NC
*********************************************************************************************/
BOOL ValidaComb(unsigned char comb[4])
{ 
	BOOL retorno=0;
	if(comb[0]!=comb[1]&&comb[0]!=comb[2]&&comb[1]!=comb[2])
	{
		if(comb[0]!=0&&comb[1]!=0&&comb[2]!=0)
		{
			retorno=1;
		}
	}
	return retorno;
}




