/********************************************************************
 FileName:     	i2c.h
 Dependencies:	See INCLUDES section
 Processor:		24F
 Hardware:		
 Complier:  
 Company:		UB
********************************************************************/
//This file contains the function prototypes for the i2c function
#define PAGESIZE	4

#define ADDR_PUNT_INI_L_EEPROM_H 		0xF9
#define ADDR_PUNT_INI_L_EEPROM_L 		0xFC
#define ADDR_PUNT_INI_H_EEPROM_H 		0xF9
#define ADDR_PUNT_INI_H_EEPROM_L 		0xFD
#define ADDR_PUNT_FIN_L_EEPROM_H 		0XF9
#define ADDR_PUNT_FIN_L_EEPROM_L 		0XFE
#define ADDR_PUNT_FIN_H_EEPROM_H 		0XF9
#define ADDR_PUNT_FIN_H_EEPROM_L 		0XFF
#define ADDR_AVERIA1_EEPROM_H 			0xF9
#define ADDR_AVERIA1_EEPROM_L 			0xFC
#define ADDR_AVERIA2_EEPROM_H 			0xF9
#define ADDR_AVERIA2_EEPROM_L 			0xFD
#define ADDR_CONTROL_EEPROM_H 			0xF9
#define ADDR_CONTROL_EEPROM_L 			0xFE
#define ADDR_PRUEBA_EEPROM_H 			0XF9
#define ADDR_PRUEBA_EEPROM_L 			0XFF
#define K_Control_M0_B0					0XA0
#define K_Control_M0_B1					0XA2
#define K_Control_M1_B0					0XA4
#define K_Control_M1_B1					0XA6
#define K_Control_M2_B0					0XA8
#define K_Control_M2_B1					0XAA
//	ControlByte.bit0 R/!W 1-->Read 0 Write
//	ControlByte.bit1 B0	Bloc select
//	ControlByte.bit2 A1	Chip select Low	
//	ControlByte.bit3 A2	Chip Select High
//Low Level Functions
unsigned int IdleI2C(void);
unsigned int StartI2C(void);
unsigned int WriteI2C(unsigned char);
unsigned int StopI2C(void);
unsigned int RestartI2C(void);
unsigned int getsI2C(unsigned char*, unsigned char);
unsigned int NotAckI2C(void);
unsigned int InitI2C(void);
unsigned int ACKStatus(void);
unsigned int getI2C(void);
unsigned int AckI2C(void);
unsigned int EEAckPolling(unsigned char);
unsigned int putstringI2C(unsigned char*);

//High Level Functions for Low Density Devices
unsigned int LDByteReadI2C(unsigned char, unsigned char, unsigned char*, unsigned char);
unsigned int LDByteWriteI2C(unsigned char, unsigned char, unsigned char);
unsigned int LDPageWriteI2C(unsigned char, unsigned char, unsigned char*);
unsigned int LDSequentialReadI2C(unsigned char, unsigned char, unsigned char*, unsigned char);

//High Level Functions for High Density Devices
unsigned int HDByteReadI2C(unsigned char, unsigned char, unsigned char, unsigned char*, unsigned char);
unsigned int HDByteWriteI2C(unsigned char, unsigned char, unsigned char, unsigned char);
unsigned int HDPageWriteI2C(unsigned char, unsigned char, unsigned char, unsigned char*);
unsigned int HDSequentialReadI2C(unsigned char, unsigned char, unsigned char, unsigned char*, unsigned char);
