/********************************************************************
 FileName:     	uart.h
 Dependencies:	See INCLUDES section
 Processor:		24F
 Hardware:		
 Complier:  
 Company:		UB
********************************************************************/
#ifndef __UART1_H__
#define __UART1_H__

/* _____STANDARD INCLUDES____________________________________________________ */

/* _____PROJECT INCLUDES_____________________________________________________ */
#include "GenericTypeDefs.h"
#include <p24Fxxxx.h>
#include "InterruptTimer.h"
/* _____DEFINITIONS _________________________________________________________ */

/* _____TYPE DEFINITIONS_____________________________________________________ */

/* _____GLOBAL VARIABLES_____________________________________________________ */

/* _____GLOBAL FUNCTION DECLARATIONS_________________________________________ */
void 			uart1_init(void);
void 			uart_change_baud(unsigned int baud);
BOOL 			uart_rx_buffer_empty(void);
BOOL 			uart_rx_buffer_full(void);
BOOL 			uart_tx_buffer_empty(void);
BOOL 			uart_tx_buffer_full(void);
BOOL 			uart_tx_finished(void);
unsigned int 	uart_tx_data(unsigned char* data, unsigned int bytes_to_send);
unsigned int 	uart_rx_data(unsigned char* buff, unsigned int bytes_to_read);
BOOL			setDataBufferRX(unsigned char data);
BOOL 			getDataBufferTX(unsigned char* data);
void 			flush_uart_rx_buffer(void);
BOOL 			getTramaUartRecivida(void);
void 			setTramaUartRecivida(BOOL valor);
#endif