/********************************************************************
 FileName:     	usb_hal_pic24.c
 Dependencies:	See INCLUDES section
 Processor:		24F
 Hardware:		
 Complier:  
 Company:		UB
********************************************************************/


#ifndef USB_HAL_PIC24F_C
#define USB_HAL_PIC24F_C

#include "usb.h"

#if defined(__C30__) || defined __XC16__

/********************************************************************
Function:
    BOOL USBSleepOnSuspend(void)

*******************************************************************/
BOOL USBSleepOnSuspend(void)
{
    unsigned int U1EIE_save, U1IE_save, U1OTGIE_save;
    unsigned char USB1IE_save;

    //Guardamos interrupcionos y setting CPU
    U1EIE_save = U1EIE;
    U1IE_save = U1IE;
    U1OTGIE_save = U1OTGIE;
    USB1IE_save = IEC5bits.USB1IE;

    //Deshabilitamos interrupciones
    U1EIE = 0;
    U1IE = 0;
    U1OTGIE = 0; 

    //Habilitamos interrupciones
    IFS5bits.USB1IF = 0;
    U1OTGIEbits.ACTVIE = 1;
    USBClearInterruptFlag(USBActivityIFReg,USBActivityIFBitNum);
    IEC5bits.USB1IE = 1;

    Sleep();

    //Restauramos valores guardados anteriores
    IEC5bits.USB1IE = USB1IE_save;
    U1EIE = U1EIE_save;
    U1IE = U1IE_save;
    U1OTGIE = U1OTGIE_save;

    return TRUE;
}

#endif //__C30__

#endif //USB_HAL_PIC24F_C
