
Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Imports System.Text
Imports System.IO


Public Class ClienteEth

    Private Stm As Stream 'Utilizado para enviar datos al Servidor y recibir datos del mismo
    Private m_IPDelHost As String 'Direccion del Servidor
    Private m_PuertoDelHost As String 'Puerto del Servidor
    Dim tcpClnt As TcpClient
    Dim tcpThd As Thread 'Se encarga de escuchar mensajes enviados por el Servidor


    Public Event ConexionTerminada()
    Public Event DatosRecibidos(ByVal mBuffer As Byte())


    Public Property IPDelHost() As String
        Get
            IPDelHost = m_IPDelHost
        End Get

        Set(ByVal Value As String)
            m_IPDelHost = Value
        End Set

    End Property



    Public Property PuertoDelHost() As String
        Get
            PuertoDelHost = m_PuertoDelHost
        End Get
        Set(ByVal Value As String)
            m_PuertoDelHost = Value
        End Set
    End Property


    Public Sub Conectar()
        tcpClnt = New TcpClient()
        'Connect a la IP y puerto del servidor
        tcpClnt.Connect(IPDelHost, PuertoDelHost)
        'udpClnt.Connect(IPDelHost, PuertoDelHost)

        Stm = tcpClnt.GetStream()

        tcpThd = New Thread(AddressOf LeerSocket)
        tcpThd.Start()

    End Sub

    Public Sub DesConectar()
        If ConectadoETH Then
            tcpClnt.Close()
        End If
    End Sub

    Public Function EnviaTramaETH(ByVal mBuffer As Byte()) As Boolean
        Dim crc As Byte
        crc = 0
        For i As Integer = 0 To mBuffer.Length - 3
            crc = crc Xor mBuffer(i)
        Next
        mBuffer(mBuffer.Length - 2) = crc
        If Not (Stm Is Nothing) Then
            'Envio los datos al Servidor
            Stm.Write(mBuffer, 0, mBuffer.Length)
        End If
        EnviaTramaETH = True
    End Function


    Private Sub LeerSocket()
        Dim BufferDeLectura() As Byte
        While True
            Try
                BufferDeLectura = New Byte(300) {}
                'Lectura del socket
                Stm.Read(BufferDeLectura, 0, BufferDeLectura.Length)
                'Generar el evento DatosRecibidos
                RaiseEvent DatosRecibidos(BufferDeLectura)
            Catch e As Exception
                Exit While
            End Try
        End While
        'generar Evento conexionterminada
        RaiseEvent ConexionTerminada()
    End Sub

End Class
